<?php
/**
* @package RSMediaGallery!
* @copyright (C) 2011 - 2021 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');

class JFormFieldResolution extends JFormField {

	protected $type = 'Resolution';
	
	public function __construct($parent = null) {
		static $added;

		parent::__construct($parent);
		
		if (!$added) {
			// load language
			$lang = JFactory::getLanguage();
			$lang->load('com_rsmediagallery.common', JPATH_ADMINISTRATOR);
			
			// add javascript
			$doc = JFactory::getDocument();
			$doc->addScriptDeclaration("function rsmgChangeOther(id) {
			    var select  = document.getElementById(id),
			        value   = select.value == 'h' ? '".JText::_('COM_RSMEDIAGALLERY_PARAM_WIDTH', true)."' : '".JText::_('COM_RSMEDIAGALLERY_PARAM_HEIGHT', true)."';
			        
				document.getElementById('rsmg_other_' + id).textContent = value;
			}");
			
			$added = true;
		}
	}
	
	protected function getInput() {
		require_once JPATH_ADMINISTRATOR.'/components/com_rsmediagallery/helpers/helper.php';
		
		$name  		    = $this->name;
		$field_name     = $this->fieldname;
		$value 		    = $this->value;

		$class 		    = $this->element['class'];
        $jversion       = RSMediaGalleryHelper::getJoomlaVersion();
        $select_class   = $jversion == '4' ? $class . ' custom-select' : $class;
        $input_class    = $jversion == '4' ? $class . ' form-control' : $class;
        $input_style    = $jversion == '4' ? '' : 'style="text-align: center;" ';

		$size 		    = isset($this->element['size']) ? 'size="'.$this->element['size'].'"' : '';
		$value		    = is_array($value) ? $value : explode(',', $value);

		if (!isset($value[1])) {
            $value[1] = '0';
        }
		
		$options = array(
			JHtml::_('select.option', 'w', JText::_('COM_RSMEDIAGALLERY_PARAM_WIDTH')),
			JHtml::_('select.option', 'h', JText::_('COM_RSMEDIAGALLERY_PARAM_HEIGHT'))
		);
		
		$select = JHtml::_('select.genericlist', $options, $name.'[]', 'onchange="rsmgChangeOther(\''.addslashes($field_name.'_w').'\')" class="'.$select_class.'"', 'value', 'text', $value[0], $field_name.'_w');
		$input	= ' <input '.$input_style.'type="text" name="'.$name.'[]" id="'.$field_name.'_res" 
		value="'.(int) $value[1].'" class="'.$input_class.'" '.$size.' /> ';
		$other	= $value[0] == 'h' ? JText::_('COM_RSMEDIAGALLERY_PARAM_WIDTH') : JText::_('COM_RSMEDIAGALLERY_PARAM_HEIGHT');
		
		return sprintf(JText::_('COM_RSMEDIAGALLERY_PARAM_SIZE_ADJUST'), $select, $input, $field_name.'_w', $other);
	}
}