<?php
/**
* @package RSMediaGallery!
* @copyright (C) 2011 - 2021 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');

class JFormFieldWidthresolution extends JFormField {

	protected $type = 'Widthresolution';
	
	public function __construct($parent = null) {
		parent::__construct($parent);
	}
	
	protected function getInput() {
        require_once JPATH_ADMINISTRATOR.'/components/com_rsmediagallery/helpers/helper.php';

		$name  		    = $this->name;
		$field_name     = $this->fieldname;
		$value 		    = $this->value;

		$class 		    = $this->element['class'];
        $jversion       = RSMediaGalleryHelper::getJoomlaVersion();
        $select_class   = $jversion == '4' ? $class . ' custom-select' : $class;
        $input_class    = $jversion == '4' ? $class . ' form-control' : $class;
        $input_style    = $jversion == '4' ? '' : 'style="text-align: center;" ';

		$size 		    = isset($this->element['size']) ? 'size="'.$this->element['size'].'"' : '';
		$value		    = is_array($value) ? $value : explode(',', $value);

		if (!isset($value[1])) $value[1] = '0';

		$options = array(
			JHtml::_('select.option', 'w', JText::_('COM_RSMEDIAGALLERY_PARAM_WIDTH'))
		);
		
		$select = JHtml::_('select.genericlist', $options, $name.'[]', 'onchange="rsmgChangeOther(\''.addslashes($field_name.'_w').'\', this.value)" class="'.$select_class.'"', 'value', 'text', $value[0], $field_name.'_w');
		$input	= ' <input '.$input_style.'type="text" name="'.$name.'[]" id="'.$field_name.'_res" value="'.(int)$value[1].'" class="'.$input_class.'" '.$size.' /> ';
		$other	= JText::_('COM_RSMEDIAGALLERY_PARAM_HEIGHT');
		
		return sprintf(JText::_('COM_RSMEDIAGALLERY_PARAM_SIZE_ADJUST'), $select, $input, $field_name.'_w', $other);
	}
}