<?php
/**
* @package RSMediaGallery!
* @copyright (C) 2011 - 2021 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');

class RSMediaGalleryViewRsmediagallery extends JViewLegacy
{
	public function display($tpl = null)
	{
        $document 	= JFactory::getDocument();
        $version	= (string) new RSMediaGalleryVersion;
        $min        = JDEBUG ? '' : '.min';

		require_once JPATH_ADMINISTRATOR.'/components/com_rsmediagallery/helpers/helper.php';
		
		$jversion 	= RSMediaGalleryHelper::getJoomlaVersion();
		
        // CSS
        JHtml::_('stylesheet', 'com_rsmediagallery/jquery.ui.css',          array('relative' => true, 'version' => $version));
        JHtml::_('stylesheet', 'com_rsmediagallery/jquery.superfish.css',   array('relative' => true, 'version' => $version));
        JHtml::_('stylesheet', 'com_rsmediagallery/cropper.css',            array('relative' => true, 'version' => $version));
        JHtml::_('stylesheet', 'com_rsmediagallery/magnific-popup.css',     array('relative' => true, 'version' => $version));
        JHtml::_('stylesheet', 'com_rsmediagallery/icons.css',        		array('relative' => true, 'version' => $version));
        JHtml::_('stylesheet', 'com_rsmediagallery/admin-style.css',        array('relative' => true, 'version' => $version));

        // Javascript
		JHtml::_('jquery.framework');
		JHtml::_('bootstrap.modal');
		if ($jversion == '3') {
			JHtml::_('bootstrap.tooltipExtended');
		}
		JHtml::_('bootstrap.popover');

        JHtml::_('script', 'com_rsmediagallery/jquery.ui'.$min.'.js',                       array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.superfish'.$min.'.js',                array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.timers'.$min.'.js',                   array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.dropshadow'.$min.'.js',               array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.magnific-popup'.$min.'.js',           array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/cropper'.$min.'.js',                         array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.cropper'.$min.'.js',                  array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.fileupload'.$min.'.js',               array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.iframe-transport'.$min.'.js',         array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.postmessage-transport'.$min.'.js',    array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.xdr-transport'.$min.'.js',            array('relative' => true, 'version' => $version));
        JHtml::_('script', 'com_rsmediagallery/jquery.admin-script'.$min.'.js',             array('relative' => true, 'version' => $version));

		$document->addScriptDeclaration("var rsmg_jversion = ".RSMediaGalleryHelper::getJoomlaVersion().";");
		
		$document->addScriptDeclaration("function rsmgGetBootstrapElement(element, value) {
			if (element == 'row') {
				if (rsmg_jversion == 3) {
					element = 'row-fluid';
				}
			} else if (element.match(/^-?\d+$/) && element > 0) {
				if (rsmg_jversion == 4) {
					element = 'col-md-' . element;
				} else {
					element = 'span' . element;
				}
			} else if (element == 'form-group') {
				if (rsmg_jversion == 4) {
					element = 'form-group';
				} else {
					element = 'control-group';
				}
			} else if (element == 'data') {
				if (rsmg_jversion == 4) {
					element = 'data-bs-' + value;
				} else {
					element = 'data-' + value;
				}
			}
			
			return element;
		}");

		$document->addScriptDeclaration("function rsmgGetRoot() { return '".addslashes(rtrim(JUri::root(), '/'))."'; }");

		$document->addScriptDeclaration("function rsmgGetLang(id) {
			switch (id)
			{
				default: return id;
				case 'COM_RSMEDIAGALLERY_UNPUBLISHED': 	                    return '".JText::_('COM_RSMEDIAGALLERY_UNPUBLISHED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_PUBLISHED': 		                return '".JText::_('COM_RSMEDIAGALLERY_PUBLISHED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_PUBLISH_DESC': 	                return '".JText::_('COM_RSMEDIAGALLERY_PUBLISH_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_UNPUBLISH_DESC':                   return '".JText::_('COM_RSMEDIAGALLERY_UNPUBLISH_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_BTN_TAGS_DESC': 	                return '".JText::_('COM_RSMEDIAGALLERY_BTN_TAGS_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_BTN_NO_TAGS_DESC': 	            return '".JText::_('COM_RSMEDIAGALLERY_BTN_NO_TAGS_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_PREVIEW_DESC': 	                return '".JText::_('COM_RSMEDIAGALLERY_PREVIEW_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_EDIT_DESC': 		                return '".JText::_('COM_RSMEDIAGALLERY_EDIT_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_DELETE_DESC': 	                    return '".JText::_('COM_RSMEDIAGALLERY_DELETE_DESC', true)."'; break;
				case 'COM_RSMEDIAGALLERY_LOAD_MORE': 		                return '".JText::_('COM_RSMEDIAGALLERY_LOAD_MORE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_LOAD_ALL': 		                return '".JText::_('COM_RSMEDIAGALLERY_LOAD_ALL', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ARE_YOU_SURE': 	                return '".JText::_('COM_RSMEDIAGALLERY_ARE_YOU_SURE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_DELETE':                           return '".JText::_('COM_RSMEDIAGALLERY_DELETE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_CANCEL':                           return '".JText::_('COM_RSMEDIAGALLERY_CANCEL', true)."'; break;
				case 'COM_RSMEDIAGALLERY_CLOSE':                            return '".JText::_('COM_RSMEDIAGALLERY_CLOSE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_SAVE_CHANGES':                     return '".JText::_('COM_RSMEDIAGALLERY_SAVE_CHANGES', true)."'; break;
				case 'COM_RSMEDIAGALLERY_PLEASE_WAIT':                      return '".JText::_('COM_RSMEDIAGALLERY_PLEASE_WAIT', true)."'; break;
				case 'COM_RSMEDIAGALLERY_TAGS_HAVE_BEEN_ADDED': 	        return '".JText::_('COM_RSMEDIAGALLERY_TAGS_HAVE_BEEN_ADDED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_TAGS_HAVE_BEEN_REMOVED':           return '".JText::_('COM_RSMEDIAGALLERY_TAGS_HAVE_BEEN_REMOVED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_CLEAR_ALL_FILTERS':                return '".JText::_('COM_RSMEDIAGALLERY_CLEAR_ALL_FILTERS', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ITEMS_PER_PAGE':                   return '".JText::_('COM_RSMEDIAGALLERY_ITEMS_PER_PAGE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_SELECT_ALL_PAGES': 		        return '".JText::_('COM_RSMEDIAGALLERY_SELECT_ALL_PAGES', true)."'; break;
				case 'COM_RSMEDIAGALLERY_SELECT_ALL':                       return '".JText::_('COM_RSMEDIAGALLERY_SELECT_ALL', true)."'; break;
				case 'COM_RSMEDIAGALLERY_CHANGES_APPLIED':                  return '".JText::_('COM_RSMEDIAGALLERY_CHANGES_APPLIED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ITEM_SAVED':                       return '".JText::_('COM_RSMEDIAGALLERY_ITEM_SAVED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ITEM_DELETED':                     return '".JText::_('COM_RSMEDIAGALLERY_ITEM_DELETED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ITEMS_DELETED':                    return '".JText::_('COM_RSMEDIAGALLERY_ITEMS_DELETED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_SELECTED_ITEMS':                   return '".JText::_('COM_RSMEDIAGALLERY_SELECTED_ITEMS', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_ADD_TO_GALLERY':            return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_ADD_TO_GALLERY', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_FINAL_SUCCESS':             return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_FINAL_SUCCESS', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_SELECT_ITEMS':              return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_SELECT_ITEMS', true)."'; break;
				
				case 'COM_RSMEDIAGALLERY_IMPORT_PREVIEW':                   return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_PREVIEW', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_FILE':                      return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_FILE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_DIMENSIONS':                return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_DIMENSIONS', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_SELECT':                    return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_SELECT', true)."'; break;
				case 'COM_RSMEDIAGALLERY_IMPORT_SELECT_ALL':                return '".JText::_('COM_RSMEDIAGALLERY_IMPORT_SELECT_ALL', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ERROR_FILTER_VALUE':               return '".JText::_('COM_RSMEDIAGALLERY_ERROR_FILTER_VALUE', true)."'; break;
				case 'COM_RSMEDIAGALLERY_ERROR_FILTER_MEMORY_LIMIT_VALUE':  return '".JText::_('COM_RSMEDIAGALLERY_ERROR_FILTER_MEMORY_LIMIT_VALUE', true)."'; break;
				
				case 'COM_RSMEDIAGALLERY_USE_SELECTED':                     return '".JText::_('COM_RSMEDIAGALLERY_USE_SELECTED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_REMOVE_SELECTED':                  return '".JText::_('COM_RSMEDIAGALLERY_REMOVE_SELECTED', true)."'; break;
				case 'COM_RSMEDIAGALLERY_NO_TAGS':                          return '".JText::_('COM_RSMEDIAGALLERY_NO_TAGS', true)."'; break;
				case 'COM_RSMEDIAGALLERY_NO_TAGS_SELCTED':                  return '".JText::_('COM_RSMEDIAGALLERY_NO_TAGS_SELCTED', true)."'; break;
				
			}
		}");

		$filters                    = $this->get('filters');
		$this->columns 		        = $filters[0];
		$this->operators            = $filters[1];
		$this->values		        = $filters[2];

		$orderings                  = $this->get('orderings');
		$this->ordering 	        = $orderings[0];
		$this->direction 	        = $orderings[1];

		$this->hasNoItems           = $this->get('hasnoitems');
		$this->limit                = $this->get('limit');

		$this->version              = (string) new RSMediaGalleryVersion();
		$this->code                 = $this->get('updateCode');
		$this->isMissingCode        = strlen($this->code) == 0;
		$this->isIncorrectCode      = strlen($this->code) > 0 && strlen($this->code) != 20;
		$this->isCorrectCode        = strlen($this->code) == 20;

		$this->imageFilterExists    = function_exists('imagefilter');
		$this->imageEffects			= array(
			'sepia', 'amaro', 'nashville', 'seventyseven', 'highcontrast', 'light', 'vintage', 'hot', 'blueseasoning', 'stretch', 'greenhornet', 'grounded', 'coldbreeze', 'diva', 'lifeonmars',  'morning', 'oldphoto', 'deepfocus', 'wornvintage', 'mist', 'overblown'
		);

        $this->addToolBar();

		parent::display($tpl);
	}

    protected function addToolbar()
    {
        JToolBarHelper::title('RSMediaGallery!','rsmediagallery');

        JToolBarHelper::custom('upload', 'upload', 'upload', 'COM_RSMEDIAGALLERY_UPLOAD', false);
        JToolBarHelper::custom('import', 'loop', 'loop', 'COM_RSMEDIAGALLERY_IMPORT', false);

        JToolbarHelper::publish('publish', 'COM_RSMEDIAGALLERY_PUBLISH', false);
        JToolbarHelper::unpublish('unpublish', 'COM_RSMEDIAGALLERY_UNPUBLISH', false);

        JToolBarHelper::custom('tag', 'tags', 'tags', 'COM_RSMEDIAGALLERY_TAG', false);
        JToolBarHelper::custom('delete', 'trash', 'trash', 'COM_RSMEDIAGALLERY_DELETE', false);

        $user = JFactory::getUser();
        if ($user->authorise('core.admin', 'com_rsmediagallery')) {
            JToolBarHelper::preferences('com_rsmediagallery');
        }
    }

	protected function translate($text)
	{
		switch ($text)
		{
			// columns & ordering
			case 'title':
			case 'i.title':
				return JText::_('COM_RSMEDIAGALLERY_TITLE');
			break;
			
			case 'description':
			case 'i.description':
				return JText::_('COM_RSMEDIAGALLERY_DESC');
			break;
			
			case 'tags':
			case 't.tag':
				return JText::_('COM_RSMEDIAGALLERY_TAGS');
			break;
			
			case 'hits':
			case 'i.hits':
				return JText::_('COM_RSMEDIAGALLERY_HITS');
			break;
			
			case 'published':
				return JText::_('COM_RSMEDIAGALLERY_PUBLISHED');
			break;
			
			case 'created':
			case 'i.created':
				return JText::_('COM_RSMEDIAGALLERY_CREATED_DATE');
			break;
			
			case 'modified':
			case 'i.modified':
				return JText::_('COM_RSMEDIAGALLERY_MODIFIED_DATE');
			break;
			
			// operators
			case 'is':
				return JText::_('COM_RSMEDIAGALLERY_IS');
			break;
			
			case 'is_not':
				return JText::_('COM_RSMEDIAGALLERY_IS_NOT');
			break;
			
			case 'contains':
				return JText::_('COM_RSMEDIAGALLERY_CONTAINS');
			break;
			
			case 'contains_not':
				return JText::_('COM_RSMEDIAGALLERY_DOES_NOT_CONTAIN');
			break;
			
			// ordering
			case 'i.ordering':
				return JText::_('COM_RSMEDIAGALLERY_FREE_ORDERING');
			break;
			
			// direction
			case 'asc':
				return JText::_('COM_RSMEDIAGALLERY_ASCENDING');
			break;
			
			case 'desc':
				return JText::_('COM_RSMEDIAGALLERY_DESCENDING');
			break;
		}
	}
}