var rsmg_img_cropper;

jQuery.noConflict();
jQuery(document).ready(function() {
	rsmgInitToolbar();
	rsmgInitSuperfish();
	rsmgInitAutocomplete();
	rsmgGetItems(false);
	rsmgInitLoadMore();
	rsmgInitUpload();

	if (jQuery('#rsmg-modal-no-items').length > 0) {
		jQuery('#rsmg-modal-no-items').modal('show');
	}

	Joomla.submitbutton = function(task) {
		rsmgSubmit(task);

		return false;
	}
});

// Toolbars
function rsmgInitToolbar() {
	jQuery('#rsmg-select-all').on('click', function(e) {
		jQuery('.rsmg-item').addClass('ui-selected');

		if (e.shiftKey) {
			jQuery('#rsmg-select-all').attr('rel', 1);
		} else {
			jQuery('#rsmg-select-all').attr('rel', 0);
		}

        rsmgShowSelected();
	});

	jQuery('#rsmg-filter').on('click', function(e) {
		e.preventDefault();

		if (jQuery('#rsmg-filter-text').val().trim().length > 0) {
			var text = jQuery('#rsmg-filter-text').val();

			if (jQuery('#rsmg-column ul li a.rsmg-tick').attr('rel') != 'published') {
				jQuery('#rsmg-filter-text').val('');
			}

			var current_column	 = jQuery('#rsmg-column .rsmg-tick').attr('rel'),
				current_operator = jQuery('#rsmg-operator .rsmg-tick').attr('rel'),

				already_columns   = document.getElementsByName('rsmg_columns[]'),
				already_operators = document.getElementsByName('rsmg_operators[]'),
				already_values	  = document.getElementsByName('rsmg_values[]');

			for (var i = 0; i < already_columns.length; i++) {
				if (jQuery(already_columns[i]).val() == current_column && jQuery(already_operators[i]).val() == current_operator && jQuery(already_values[i]).val() == text) {
					return;
				}
			}

			var li 			= jQuery('<li>'),
				col 		= jQuery('<span>').html(jQuery('#rsmg-column > a').html()),
				operator 	= jQuery('<span>').html(jQuery('#rsmg-operator > a').html()),
				value		= jQuery('<strong>').text(text),
				close 		= jQuery('<a>', {'href': 'javascript: void(0)', 'class': 'rsmg-close'}).click(function(e) {
					e.preventDefault();

					jQuery(this).parent('li').hide('highlight', 500, function() {
						jQuery(this).remove();
						rsmgGetItems(true);

						if (jQuery('.rsmg-filters li').length == 1 && jQuery('.rsmg-clear-filters').length > 0) {
							jQuery('.rsmg-clear-filters').remove();
						}
					});
				}),
				input_col 		= jQuery('<input>', {'type': 'hidden', 'name': 'rsmg_columns[]', 'value': current_column}),
				input_operator  = jQuery('<input>', {'type': 'hidden', 'name': 'rsmg_operators[]', 'value': current_operator}),
				input_value 	= jQuery('<input>', {'type': 'hidden', 'name': 'rsmg_values[]', 'value': text});

			// Do not show "value" for filters that use the published column
			if (current_column == 'published') {
				value.text('');
				close.css({
					'margin-left'	: 0,
					'padding-left'	: 0,
					'border-left'	: 0
				});
			}

			jQuery('.rsmg-filters').append(li.append(col, operator, value, close, input_col, input_operator, input_value));
			jQuery('.rsmg-clear-filters').remove();

			if (jQuery('.rsmg-filters').children().length > 2) {
				var clear = jQuery('<li>', {'class': 'rsmg-clear-filters'}).html(rsmgGetLang('COM_RSMEDIAGALLERY_CLEAR_ALL_FILTERS')).click(function(e) {
					e.preventDefault();

					jQuery('.rsmg-filters').children().hide('highlight', 500, function() {
						jQuery(this).remove();
					});
					window.setTimeout(function() {
						rsmgGetItems(true);
					}, 550);
				});

				jQuery('.rsmg-filters').append(clear);
			}
		}

		rsmgGetItems(true);
	});

	// Use this to trigger the filtering when enter is pressed and the form is submitted
	jQuery('#rsmg-filter-form').submit(function(e) {
		e.preventDefault();

		jQuery('#rsmg-filter').trigger('click');
	});

	// If there are any filters from the session, initialize the clicks
	jQuery('.rsmg-close').click(function(e) {
		e.preventDefault();

		jQuery(this).parent('li').hide('highlight', 500, function() {
			jQuery(this).remove();
			rsmgGetItems(true);

			if (jQuery('.rsmg-filters li').length == 1 && jQuery('.rsmg-clear-filters').length > 0) {
				jQuery('.rsmg-clear-filters').remove();
			}
		});
	});

	jQuery('.rsmg-clear-filters').click(function(e) {
		e.preventDefault();

		jQuery('.rsmg-filters').children().hide('highlight', 500, function() { jQuery(this).remove(); });
		window.setTimeout(function() {
			rsmgGetItems(true);
		}, 550);
	});

	jQuery('#rsmg-view-all-tags').click(function() {
		RSMediaGallery.Tags.showAllTags();
		jQuery('#rsmg-modal-all-tags').modal('show');
	});
}

// Make sortable
function rsmgInitSortable() {
	jQuery('.rsmg-items').removeAttr('style');

	// Disable if not ordering - no point in ordering something that's order by eg. title
	is_disabled = jQuery('#rsmg-order ul li a.rsmg-tick').attr('rel') == 'ordering' ? false : true;

	jQuery('.rsmg-items').sortable({
		'handle'	: '.rsmg-thumb-container',
		'cursor'	: 'auto',
		'disabled'	: is_disabled,

		// Save ordering
		update		: function() {
			var cids 		= [],
				orderings	= [];

			jQuery('input[name="cid[]"]').each(function(index, el) {
				rsmg_sort_array[index].id = jQuery(el).val();

				cids.push(rsmg_sort_array[index].id);
				orderings.push(rsmg_sort_array[index].ordering);
			});

			if (cids.length > 0) {
				// Send request to save the ordering
				// because it has changed in the DOM
				jQuery.ajax({
					type	: 'POST',
					url		: 'index.php?option=com_rsmediagallery&controller=items&task=saveorder&format=raw',
					data	: {
						'cid[]'			: cids,
						'ordering[]'	: orderings
					}
				});
			}
		},
		start		: function(e, ui) {
			jQuery('.ui-selectable-helper').css('display', 'none');
			jQuery('.rsmg-items').selectable({
				disabled : true
			});
		},
		stop		: function(e, ui) {
			jQuery('.ui-selectable-helper').css('display', 'block');
			jQuery('.rsmg-items').selectable({
				disabled : false
			});
		}
	});

	if (is_disabled) {
		jQuery('.rsmg-items').addClass('ui-sortable-disabled');
	}
}

// Make selectable
function rsmgInitSelectable() {
	jQuery('.rsmg-items').on('mousedown', function(e) {
		if (e.target) {
			var target = jQuery(e.target);

			// Make ctrl-click multiselect possible
			if (e.ctrlKey == true && target == jQuery('.rsmg-items')) {
				e.metaKey = true;
			}

			// Handle bug when edit button is clicked
			if (target.hasClass('rsmg-action-button')) {
				target.trigger('click');
			} else {
				e.unbind('click');
			}
		}
	}).selectable({
		start	: function() {
			jQuery('#rsmg-select-all').attr('rel', 0);
		},
		stop	: function() {
            rsmgShowSelected();
		}
	});

	jQuery('.rsmg-item-select').on('click', function() {}).selectable({
		start	: function() {
			jQuery(this).closest('.rsmg-item').toggleClass('ui-selected');
		},
		stop    : function() {
			jQuery(this).closest('.rsmg-item').removeClass('ui-selecting');
            rsmgShowSelected();
		}
	});
}

// Create Superfish dropdowns
function rsmgInitSuperfish() {
	jQuery('.rsmg-filter-toolbar > ul').children('li').each(function(i, el) {
		var max_width = 0;

		jQuery(el).children('ul').each(function(j, ul) {
			jQuery(ul).show();
			jQuery(ul).children('li').each (function(k, li) {
				var width = jQuery(li).outerWidth();

				if (width > max_width) {
					max_width = width;
				}
			});
			jQuery(ul).hide();
		});
		if (max_width > 0) {
			jQuery(el).css('width', max_width + 'px');
		}
	});

	jQuery('.rsmg-filter-toolbar ul').superfish({
		delay		: 100,
		speed		: 'fast',
		speedOut	: 'fast'
	});

	// Filter column
	jQuery('#rsmg-column ul li a').click(function(e) {
		e.preventDefault();

		jQuery('.rsmg-filter-toolbar ul').superfish('hide');
		jQuery('#rsmg-column > a').html(jQuery(this).html());
		jQuery('#rsmg-column ul li a').removeClass('rsmg-tick');
		jQuery(this).addClass('rsmg-tick');

		if (jQuery(this).attr('rel') == 'published') {
			jQuery('#rsmg-operator ul li').each(function(index, el) {
				// Skip "is" and "is not"
				if (index > 1) {
					// This means that either "contains" or "does not contain" is ticked
					if (jQuery(el).children('.rsmg-tick').length > 0) {
						if (index == 2) {
							// If this is "contains" show "is"
							jQuery('#rsmg-operator ul li:nth-child(1) a').trigger('click');
						} else {
							// If this is "does not contain" show "is not"
							jQuery('#rsmg-operator ul li:nth-child(2) a').trigger('click');
						}
					}

					// Hide these items - they are not available for the published filter
					jQuery(el).hide();
				}
			});

			// Filtering is no longer needed for "published"
			jQuery('#rsmg-filter-text').val('1');
			jQuery('#rsmg-filter-text').hide();
		} else {
			jQuery('#rsmg-operator ul li').each(function(index, el) {
				if (index > 1) {
					jQuery(el).show();
				}
			});

			if (jQuery('#rsmg-filter-text').val() == '1') {
				jQuery('#rsmg-filter-text').val('');
			}
			jQuery('#rsmg-filter-text').show();
		}
	});

	// Operator
	jQuery('#rsmg-operator ul li a').click(function(e) {
		e.preventDefault();

		jQuery('.rsmg-filter-toolbar ul').superfish('hide');
		jQuery('#rsmg-operator > a').html(jQuery(this).html());
		jQuery('#rsmg-operator ul li a').removeClass('rsmg-tick');
		jQuery(this).addClass('rsmg-tick');
	});

	// Ordering
	jQuery('#rsmg-order ul li a').click(function(e) {
		e.preventDefault();

		jQuery('.rsmg-filter-toolbar ul').superfish('hide');
		jQuery('#rsmg-order > a').html(jQuery(this).html());
		jQuery('#rsmg-order ul li a').removeClass('rsmg-tick');
		jQuery(this).addClass('rsmg-tick');
	});

	// Direction
	jQuery('#rsmg-direction ul li a').click(function(e) {
		e.preventDefault();

		jQuery('.rsmg-filter-toolbar ul').superfish('hide');
		jQuery('#rsmg-direction > a').html(jQuery(this).html());
		jQuery('#rsmg-direction ul li a').removeClass('rsmg-tick');
		jQuery(this).addClass('rsmg-tick');
	});

	// Limit
	jQuery('#rsmg-limit ul li a').click(function(e) {
		e.preventDefault();

		jQuery('.rsmg-filter-toolbar ul').superfish('hide');
		jQuery('#rsmg-limit > a').html(jQuery(this).html());
		jQuery('#rsmg-limit ul li a').removeClass('rsmg-tick');
		jQuery(this).addClass('rsmg-tick');
	});
}

// Turn on autocomplete
function rsmgInitAutocomplete() {
	jQuery('#rsmg-filter-text').autocomplete({
		source : function(request, response) {

			// Min 2 chars
			if (request.term.length < 2) {
				return response([]);
			}

			var operator = jQuery('#rsmg-operator .rsmg-tick').attr('rel');

			if (operator == 'is') {
				operator = 'contains';
			} else if (operator == 'is_not') {
				operator = 'contains_not';
			}

			jQuery.ajax({
				type		: 'POST',
				url			: 'index.php?option=com_rsmediagallery&controller=items&task=getsuggestions&format=raw',
				dataType	: 'json',
				data		: {
					'filter_columns'	: jQuery('#rsmg-column .rsmg-tick').attr('rel'),
					'filter_operators'	: operator,
					'filter_values'		: request.term,
					'dont_remember'		: 1
				},
				success		: function(data) {
					response(data);
				}
			});
		}
	});
}

// Create popovers
function rsmgInitPopover() {
	if (rsmg_jversion == 4) {
		jQuery('[' + rsmgGetBootstrapElement('data', 'toggle') + '="popover"]').popover({
			trigger	: 'hover',
			html	: true
		});
	} else {
		
		// We need this because Bootstrap 2 Popovers can not be updated dynamically
		jQuery('[' + rsmgGetBootstrapElement('data', 'toggle') + '="popover"]').each(function() {
			var popover_element = jQuery(this);
			
			popover_element.popover({
				trigger	: 'hover',
				html	: true,
				content : popover_element.attr('data-content')
			});
		});
	}
}

function rsmgHidePopover() {
	jQuery('[' + rsmgGetBootstrapElement('data', 'toggle') + '="popover"]').popover('hide');
}

function rsmgDestroyPopover() {
	if (rsmg_jversion == 4) {
		jQuery('[' + rsmgGetBootstrapElement('data', 'toggle') + '="popover"]').popover('dispose');
	} else {
		jQuery('[' + rsmgGetBootstrapElement('data', 'toggle') + '="popover"]').popover('destroy');
	}
}

// Create Magnific popup
function rsmgInitMagnificPopup() {
	jQuery('.rsmg-action-button.rsmg-preview').magnificPopup({
		type		: 'image',
		image		: {
			verticalFit	: true
		},
		mainClass	: 'mfp-with-zoom'
	});
}

// Create image toolbar
function rsmgInitImageToolbar() {
	// Click on delete
	jQuery('.rsmg-delete').unbind('click');
	jQuery('.rsmg-delete').click(function() {
		var self    = jQuery(this),
			parent  = self.parents('li.rsmg-item'),
			cid 	= parent.children('input[name="cid[]"]').val();

		rsmgDeleteItems(parent, cid, true);
	});

	// Click on edit
	jQuery('.rsmg-edit').on('click', function() {
		
		// Add details loader
		RSMediaGallery.Loader.add();
		
		// Hide popovers
		rsmgHidePopover();
		
		jQuery('.rsmg-items').css('cursor', 'default');

		// Get the parent container
		var item = jQuery(this).closest('.rsmg-item');

		item.addClass('rsmg-edit-item');

		// Do not trigger if clicked twice or details already showing
		if (item.find('.rsmg-loader-container').length > 0 || jQuery('.rsmg-item-details').css('display') == 'block') {
			return;
		}

		// Add loading icon on thumb
		item.find('.rsmg-thumb-container').append('<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>');

		var details_thumb_img = jQuery('.rsmg-details-thumb-container img');

		jQuery.ajax({
			type		: 'POST',
			url			: 'index.php?option=com_rsmediagallery&controller=items&task=getitem&format=raw',
			dataType	: 'json',
			data		: {
				'cid'	: item.children('input[name="cid[]"]').val()
			},
			beforeSend	: function() {
				jQuery('#rsmg-details-title').val('');
				jQuery('#rsmg-details-description').val('');
				jQuery('#rsmg-details-url').val('');
				jQuery('#rsmg-details-tags').val('');
				jQuery('#rsmg-selection-res').html('');
				jQuery('#rsmg-selection-ratio').html('');
				jQuery('#rsmg-image-res').html('').removeClass('rsmg-red');
				jQuery('#rsmg-size-on-disk').html('');
				jQuery('#rsmg-save-result').html('').removeClass('rsmg-error alert alert-error');
			},
			success		: function(data) {
				if (typeof data == 'object' && data.id) {

					// Get src to original image
					var original_src	= item.find('img').attr('original-src'),
						original_height	= item.find('img').attr('original-height'),
						original_width	= item.find('img').attr('original-width');

					details_thumb_img.attr('src', original_src);
					details_thumb_img.attr('original-height', original_height);
					details_thumb_img.attr('original-width', original_width);

					// Image has been loaded
					jQuery('<img>', {'src': original_src}).on('load', function() {

						if (!data.params.selection) {
							data.params.selection = {x1: 0, x2: 300, y1: 0, y2: jQuery('.rsmg-details-thumb-container img').height()};
						}

						jQuery('#rsmg-details-title').val(data.title);
						jQuery('#rsmg-details-description').val(data.description);
						jQuery('#rsmg-details-url').val(data.url);
						jQuery('#rsmg-details-tags').val(data.tags);

						if (data.published == 1) {
							jQuery('#rsmg-details-published').prop('checked', true);
						} else {
                            jQuery('#rsmg-details-published').prop('checked', false);
                        }

						if (data.free_aspect == 1) {
							jQuery('#rsmg-details-free-aspect').prop('checked', true);
						} else {
							jQuery('#rsmg-details-free-aspect').prop('checked', false);
						}

						jQuery('#rsmg-details-hits').html(data.hits);
						jQuery('#rsmg-details-created-date').html(data.created);
						jQuery('#rsmg-details-modified-date').html(data.modified);

						var highlight = (data.params.info[0] > 1980 || data.params.info[1] > 1980) ? 'rsmg-red' : 'rsmg-green';

						jQuery('#rsmg-image-res').html(data.params.info[0] + ' x ' + data.params.info[1]);
						jQuery('#rsmg-image-res').addClass(highlight);
						jQuery('#rsmg-size-on-disk').html(data.imgsize);

						// Set the effects filters
						RSMediaGallery.Filters.setFiltersValues(data.params.filters);

						// Show picture title
						jQuery('.rsmg-details-heading').html(data.title);

						jQuery('.rsmg-item-details').show('fade', 300, function() {
							var thumb_ratio			= Math.round(original_width / jQuery('.rsmg-details-thumb-container').width() * 100) / 100,
								selection			= {
									x1		: data.params.selection.x1,
									x2		: data.params.selection.x2,
									y1		: data.params.selection.y1,
									y2		: data.params.selection.y2,
									width	: data.params.selection.x2 - data.params.selection.x1,
									height	: data.params.selection.y2 - data.params.selection.y1
								};

							rsmgCalculateThumbnail(selection);
							rsmgSaveThumbnailPositions(selection);

							// Change the images if effects filters are present
							if (RSMediaGallery.Helpers.inArray(data.params.filters, RSMediaGallery.Filters.predefinedFilters)) {
								RSMediaGallery.Filters.applyFilters(data.params.filters);
							} else {
								RSMediaGallery.Filters.applyFilters('none');
							}

						}); // edit/details screen has been shown
					});
				}
			}
		});
	});

	// Click to publish / unpublish
	jQuery('.rsmg-publish').on('click', function() {

		var self	= jQuery(this),
			parent  = self.parents('li.rsmg-item'),
			cid 	= parent.children('input[name="cid[]"]').val();

		// Prevent multiple clicks while ajax is loading
		if (self.hasClass('rsmg-publish-loading')) {
			return false;
		}

		if (self.hasClass('rsmg-published')) {
            rsmgUnpublishItems(cid, function() {
					self.find('.rsmg-text').html(rsmgGetLang('COM_RSMEDIAGALLERY_UNPUBLISHED'));
					self.addClass('rsmg-unpublished');
					self.removeClass('rsmg-publish-loading');
				},
				function() {
					self.removeClass('rsmg-published');
					self.addClass('rsmg-publish-loading');
				},
				true
			);
		} else {
			rsmgPublishItems(cid, function() {
					self.find('.rsmg-text').html(rsmgGetLang('COM_RSMEDIAGALLERY_PUBLISHED'));
					self.addClass('rsmg-published');
					self.removeClass('rsmg-publish-loading');
				},
				function() {
					self.removeClass('rsmg-unpublished');
					self.addClass('rsmg-publish-loading');
				},
				true
			);
		}
	});
}

function rsmgCalculateThumbnail(selection) {
	if (!selection.width || !selection.height) {
		return;
	}

	var preview_image	= jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container img'),
		thumb_container	= jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container .rsmg-thumb'),
		free_aspect		= jQuery('#rsmg-details-free-aspect').prop('checked'),
		thumb_width		= 300,
		thumb_height	= 225;

	thumb_container.removeAttr('style');
	preview_image.removeAttr('style');

	if (free_aspect) {
		if ((selection.width > selection.height) && (selection.width / selection.height > 4 / 3)) {

			// Landscape - must calculate height & force full width
			var land_height		= Math.round(thumb_width * selection.height / selection.width),
				filler_height	= Math.floor((225 - land_height) / 2);

			thumb_height = 225 - filler_height * 2;
		} else {

			// Portrait - must calculate width & force full height
			var port_width		= Math.round(thumb_height * selection.width / selection.height),
				filler_width	= Math.floor((300 - port_width) / 2);

			thumb_width = 300 - filler_width * 2;
		}
	}

	preview_image.css({
		height	: thumb_height,
		width	: thumb_width
	});

	jQuery('#rsmg-admin-width').val(thumb_width);
	jQuery('#rsmg-admin-height').val(thumb_height);
}

function rsmgGetItemsFilter(more) {
	var columns     = [],
		operators   = [],
		values      = [];

	jQuery('input[name="rsmg_columns[]"]').each(function(index, el) {
		columns.push(jQuery(el).val());
	});
	
	if (columns.length == 0) {
		columns = '';
	}

	jQuery('input[name="rsmg_operators[]"]').each(function(index, el) {
		operators.push(jQuery(el).val());
	});

	if (operators.length == 0) {
		operators = '';
	}

	jQuery('input[name="rsmg_values[]"]').each(function(index, el) {
		values.push(jQuery(el).val());
	});

	if (values.length == 0) {
		values = '';
	}

	var data = {
		'limit'					: jQuery('#rsmg-limit ul li a.rsmg-tick').attr('rel'),
		'limitstart'			: jQuery('ul.rsmg-items li.rsmg-item').length,
		'filter_columns[]'		: columns,
		'filter_operators[]'	: operators,
		'filter_values[]'		: values,
		'order'					: jQuery('#rsmg-order ul li a.rsmg-tick').attr('rel'),
		'direction'				: jQuery('#rsmg-direction ul li a.rsmg-tick').attr('rel')
	};

	if (more) {
		for (var key in more) {
			data[key] = more[key];
		}
	}

	return data;
}

var rsmg_sort_array = [];

function rsmgGetItems(clear, more, load_more) {
	// Parent container
	var parent = jQuery('.rsmg-items');

	// Clear contents
	if (clear == true) {
		rsmg_sort_array = [];
		parent.empty();
	}

	if (!load_more) {
		parent.append('<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>');
	}

	jQuery.ajax({
		type		: 'POST',
		url			: 'index.php?option=com_rsmediagallery&controller=items&task=getitems&format=raw',
		data		: rsmgGetItemsFilter(more),
		dataType	: 'json',
		success		: function(data) {

			if (typeof data == 'object' && data.items && data.total) {
				jQuery(data.items).each(function(index, item) {
					rsmg_sort_array.push({'id': item.id, 'ordering': item.ordering});

					// Container
					var id = jQuery('<input>', {'type': 'hidden', 'name': 'cid[]', 'value': item.id}),
						li = jQuery('<li>', {'class': 'rsmg-item'});

					if (jQuery('#rsmg-select-all').attr('rel') == 1) {
						li.addClass('ui-selected');
					}

					// Thumbnail
					var thumb_container	= jQuery('<div>', {'class': 'rsmg-thumb-container'}),
						admin_width		= item.params.admin_thumb.w,
						admin_height	= item.params.admin_thumb.h,
						filter			= '';

					if (typeof item.params.filters != 'undefined') {
						if (item.params.filters != '') {
							filter = 'filter/';
						}
					}

					var img_thumb  = jQuery('<img>', {
							'src'				: rsmgGetRoot() + '/components/com_rsmediagallery/assets/gallery/' + filter + item.filename,
							'alt'				: item.title,
							'original-src'		: rsmgGetRoot() + '/components/com_rsmediagallery/assets/gallery/original/' + item.filename,
							'effect-src'		: rsmgGetRoot() + '/components/com_rsmediagallery/assets/gallery/original/'+ filter + item.filename,
							'thumb-src'			: rsmgGetRoot() + '/components/com_rsmediagallery/assets/gallery/'+ filter + item.filename,
							'original-width'	: item.params.info[0],
							'original-height'	: item.params.info[1]
						}),
						div_thumb	= jQuery('<div>', {'class': 'rsmg-thumb'});

					img_thumb.data('rsmg_data', {'admin_w': admin_width, 'admin_h': admin_height});

					var item_tags			= item.tags ? item.tags.replaceAll(',', ', ') : rsmgGetLang('COM_RSMEDIAGALLERY_BTN_NO_TAGS_DESC'),
						item_tags_title		= item.tags ? '<span class="rsmg-popover-header">' + rsmgGetLang('COM_RSMEDIAGALLERY_BTN_TAGS_DESC') + '</span>' : '',
						top_actions			= jQuery('<div>', {'class': 'rsmg-item-top-actions'}),
						bottom_actions		= jQuery('<div>', {'class': 'rsmg-item-bottom-actions'}),
						div_select			= jQuery('<div>', {'class': 'rsmg-action-button rsmg-item-select'}),
						span_select			= jQuery('<span>'),
						div_publish 	    = jQuery('<div>', {'class': 'rsmg-action-button rsmg-publish'}),
						span_publish_icon	= jQuery('<span>', {'class': 'rsmg-icon'}),
						span_publish_text	= jQuery('<span>', {'class': 'rsmg-text'}),
						span_tags			= jQuery('<span>', {'class': 'rsmg-action-button rsmg-tags'}),
						a_preview  			= jQuery('<a>', {'class': 'rsmg-action-button rsmg-preview', 'href': rsmgGetRoot() + '/components/com_rsmediagallery/assets/gallery/original/' + item.filename}),
						a_edit 	   			= jQuery('<a>', {'class': 'rsmg-action-button rsmg-edit', 'href': '#'}),
						a_delete   			= jQuery('<a>', {'class': 'rsmg-action-button rsmg-delete', 'href': '#'}),
						loader_container	= '<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>';

					// Published/unpublished
					if (item.published == 1) {
						div_publish.addClass('rsmg-published');
						span_publish_text.html(rsmgGetLang('COM_RSMEDIAGALLERY_PUBLISHED'));
					} else {
						div_publish.addClass('rsmg-unpublished');
						span_publish_text.html(rsmgGetLang('COM_RSMEDIAGALLERY_UNPUBLISHED'));
					}

					// Action buttons
					span_tags.attr(rsmgGetBootstrapElement('data', 'content'), item_tags_title + item_tags);
					span_tags.attr(rsmgGetBootstrapElement('data', 'toggle'), 'popover');
					span_tags.attr(rsmgGetBootstrapElement('data', 'container'), 'body');
					span_tags.attr(rsmgGetBootstrapElement('data', 'placement'), 'top');
					span_tags.append(jQuery('<i>',	{'class': 'rsmg-icon-tags'}));
					
					a_preview.attr(rsmgGetBootstrapElement('data', 'content'), rsmgGetLang('COM_RSMEDIAGALLERY_PREVIEW_DESC'));
					a_preview.attr(rsmgGetBootstrapElement('data', 'toggle'), 'popover');
					a_preview.attr(rsmgGetBootstrapElement('data', 'container'), 'body');
					a_preview.attr(rsmgGetBootstrapElement('data', 'placement'), 'top');
					a_preview.append(jQuery('<i>',	{'class': 'rsmg-icon-search'}));
					
					a_edit.attr(rsmgGetBootstrapElement('data', 'content'), rsmgGetLang('COM_RSMEDIAGALLERY_EDIT_DESC'));
					a_edit.attr(rsmgGetBootstrapElement('data', 'toggle'), 'popover');
					a_edit.attr(rsmgGetBootstrapElement('data', 'container'), 'body');
					a_edit.attr(rsmgGetBootstrapElement('data', 'placement'), 'top');
					a_edit.append(jQuery('<i>',		{'class': 'rsmg-icon-edit'}));
					
					a_delete.attr(rsmgGetBootstrapElement('data', 'content'), rsmgGetLang('COM_RSMEDIAGALLERY_DELETE_DESC'));
					a_delete.attr(rsmgGetBootstrapElement('data', 'toggle'), 'popover');
					a_delete.attr(rsmgGetBootstrapElement('data', 'container'), 'body');
					a_delete.attr(rsmgGetBootstrapElement('data', 'placement'), 'top');
					a_delete.append(jQuery('<i>',	{'class': 'rsmg-icon-trash'}));

					div_publish.append(span_publish_icon, span_publish_text);
					div_select.append(span_select);

					top_actions.append(div_publish, div_select);

					div_thumb.append(img_thumb);

					bottom_actions.append(span_tags, a_preview, a_edit, a_delete);

					if (load_more) {
						thumb_container.append(top_actions, div_thumb, bottom_actions, loader_container);
					} else {
						thumb_container.append(top_actions, div_thumb, bottom_actions);
					}

					li.append(id, thumb_container);

					parent.append(li);
				});

				rsmgInitItems();

				setTimeout(function () {
					parent.find('.rsmg-loader-container').remove();
				}, 200);

				// Show load more
				if (data.total > jQuery('ul.rsmg-items li.rsmg-item').length) {
					var left = data.total - jQuery('ul.rsmg-items li.rsmg-item').length;

					jQuery('.rsmg-load-more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_MORE').replace('%d', left));
					jQuery('.rsmg-load-more').attr('rel', left);
					jQuery('.rsmg-load-more').removeClass('rsmg-none');
				} else {
					var left = 0;

					jQuery('.rsmg-load-more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_MORE').replace('%d', left));
					jQuery('.rsmg-load-more').attr('rel', left);
					jQuery('.rsmg-load-more').addClass('rsmg-none');
				}

				if (clear) {
                    rsmgShowSelected();
				}
			} else {
				parent.find('.rsmg-loader-container').remove();
			}
		}
	});
}

function escapeHTML(text) {
	if (typeof text != 'undefined') {
		return text.replace(/&/g, "&amp;")
			.replace(/</g, "&lt;")
			.replace(/>/g, "&gt;")
			.replace(/"/g, "&quot;")
			.replace(/\//g, "&sol;")
			.replace(/'/g, "&#039;");
	} else {
		return '';
	}
}

function rsmgInitItems() {
	rsmgInitSortable();
	rsmgInitSelectable();
	rsmgInitImageToolbar();
	rsmgInitPopover();
	rsmgInitMagnificPopup();
}

function rsmgInitLoadMore() {
	jQuery('.rsmg-load-more').click(function(e) {
		e.preventDefault();
		e.shiftKey ? rsmgGetItems(false, {'limitall': 1, 'limit': jQuery('.rsmg-load-more').attr('rel')}, true) : rsmgGetItems(false, {}, true);
	});

	jQuery(document).keydown(function(e) {
		if (e.shiftKey) {
			jQuery('.rsmg-load-more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_ALL').replace('%d', jQuery('.rsmg-load-more').attr('rel')));
			jQuery('#rsmg-select-all').html(rsmgGetLang('COM_RSMEDIAGALLERY_SELECT_ALL_PAGES').replace('%d', parseInt(jQuery('.rsmg-load-more').attr('rel')) + parseInt(jQuery('ul.rsmg-items li.rsmg-item').length)));
		}
	});

	jQuery(document).keyup(function(e) {
		jQuery('.rsmg-load-more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_MORE').replace('%d', jQuery('.rsmg-load-more').attr('rel')));
		jQuery('#rsmg-select-all').html(rsmgGetLang('COM_RSMEDIAGALLERY_SELECT_ALL'));
	});
}

// Initialize upload field
function rsmgInitUpload() {
	jQuery('#rsmg-add-files').fileupload({
		autoUpload			: true,
		acceptFileTypes		: /(\.|\/)(gif|jpe?g|png)$/i,
		dataType			: 'json',
		url					: 'index.php?option=com_rsmediagallery&controller=items&task=uploaditem&format=raw',
		sequentialUploads	: true,
		submit				: function(e, data) {
			data.formData = {
				'tags'      : jQuery('#rsmg-add-tags-text').val().trim(),
				'published' : jQuery('#rsmg-add-published').prop('checked') ? 1 : 0,
				'freeratio' : jQuery('#rsmg-add-free-ratio').prop('checked') ? 1 : 0
			};

			return true;
		},
		start				: function() {
			jQuery('#rsmg-modal-upload-cancel').text(rsmgGetLang('COM_RSMEDIAGALLERY_PLEASE_WAIT'));
			jQuery('#rsmg-modal-upload-cancel').attr(rsmgGetBootstrapElement('data', 'dismiss'), '');
			jQuery('#rsmg-modal-upload-cancel').attr('onclick', 'return false;');
		},
		stop				: function() {
			jQuery('#rsmg-modal-upload-cancel').text(rsmgGetLang('COM_RSMEDIAGALLERY_CLOSE'));
			jQuery('#rsmg-modal-upload-cancel').attr(rsmgGetBootstrapElement('data', 'dismiss'), 'modal');
			jQuery('#rsmg-modal-upload-cancel').attr('onclick', 'rsmgGetItems(true);');
		},
		add					: function(e, data) {
			// Must check for valid extensions
			var options = jQuery(this).data('blueimpFileupload').options,
				valid	= true;

			if (!options.acceptFileTypes) {
				return valid;
			}

			jQuery.each(data.files, function(index, file) {
				if (!options.acceptFileTypes.test(file.type) && !options.acceptFileTypes.test(file.name)) {
					valid = false;
				}
			});

			if (valid && options.autoUpload == true) {
				data.submit();
			}
		},
		done				: function(e, data) {
			if (data.result && typeof data.result == 'object') {
				var li		= jQuery('<li>', {'class': data.result.error == 1 ? 'rsmg-error alert alert-error' : 'rsmg-success alert alert-success'}).html(data.result.message),
					icon	= jQuery('<span>', {'class': data.result.error == 1 ? 'rsmg-icon-times-circle' : 'rsmg-icon-check-circle'});

				li.prepend(icon);

				// Add the result to the list
				jQuery('#rsmg-modal-upload .rsmg-add-results').prepend(li);
				jQuery('#rsmg-modal-upload .rsmg-add-results + .rsmg-button').removeClass('rsmg-none');
			}
		}
	})
}

function rsmgDeleteItems(parent, cid, single) {
	var select_all = jQuery('#rsmg-select-all').attr('rel') == 1 && !single ? 1 : 0;

	jQuery('#rsmg-modal-confirm-delete').modal('show');

	jQuery('#rsmg-modal-confirm-delete-delete').on('click', function() {
		var temp_cid = cid;

		if (typeof temp_cid != 'array' && typeof temp_cid != 'object') {
			temp_cid = [cid];
		}

		for (var t = 0; t < temp_cid.length; t++) {
			for (var a = 0; a < rsmg_sort_array.length; a++) {
				if (rsmg_sort_array[a].id == temp_cid[t]) {
					rsmg_sort_array.splice(a, 1);

					break;
				}
			}
		}

		select_all = jQuery('#rsmg-select-all').attr('rel') == 1 ? 1 : 0;

		jQuery.ajax({
			type		: 'POST',
			url			: 'index.php?option=com_rsmediagallery&controller=items&task=delitems&format=raw',
			data		: rsmgGetItemsFilter({'cid[]': cid, 'selectall': select_all}),
			dataType	: 'json',
			success		: function(data) {
				if (typeof data == 'object' && data.items) {
                    rsmgShowMessage(rsmgGetLang(temp_cid.length > 1 ? 'COM_RSMEDIAGALLERY_ITEMS_DELETED' : 'COM_RSMEDIAGALLERY_ITEM_DELETED'), 'rsmg-success');

					// Remove item
					parent.hide('highlight', 200, function() {
						jQuery(this).remove();
					});
				}
			}
		});

		jQuery('#rsmg-modal-confirm-delete').modal('hide');
	});
}

function rsmgPublishItems(cid, successCallback, beforeCallback, single) {
	if (typeof successCallback != 'function') {
		successCallback = function() {};
	}
	if (typeof beforeCallback != 'function') {
		beforeCallback = function() {};
	}

	var select_all = jQuery('#rsmg-select-all').attr('rel') == 1 && !single ? 1 : 0;

	jQuery.ajax({
		type		: 'POST',
		url			: 'index.php?option=com_rsmediagallery&controller=items&task=publishitems&format=raw',
		data		: {'cid[]': cid, 'selectall': select_all},
		success		: successCallback,
		beforeSend	: beforeCallback
	});
}

function rsmgUnpublishItems(cid, successCallback, beforeCallback, single) {
	if (typeof successCallback != 'function') {
		successCallback = function() {};
	}
	if (typeof beforeCallback != 'function') {
		beforeCallback = function() {};
	}

	var select_all = jQuery('#rsmg-select-all').attr('rel') == 1 && !single ? 1 : 0;

	jQuery.ajax({
		type		: 'POST',
		url			: 'index.php?option=com_rsmediagallery&controller=items&task=unpublishitems&format=raw',
		data		: {
			'cid[]'		: cid,
			'selectall'	: select_all
		},
		success		: successCallback,
		beforeSend	: beforeCallback
	});
}

function rsmgSaveDetails(apply) {
	var parent	= jQuery('.rsmg-item.rsmg-edit-item'),
		cid		= parent.find('input[name="cid[]"]').val();

	jQuery.ajax({
		type		: 'POST',
		url			: 'index.php?option=com_rsmediagallery&controller=items&task=saveitem&format=raw',
		dataType	: 'json',
		data		: {
			'cid'			: cid,
			'title'			: jQuery('#rsmg-details-title').val(),
			'tags'			: jQuery('#rsmg-details-tags').val(),
			'description'	: jQuery('#rsmg-details-description').val(),
			'url'			: jQuery('#rsmg-details-url').val(),
			'free_aspect'	: jQuery('#rsmg-details-free-aspect').prop('checked') ? 1 : 0,
			'published'		: jQuery('#rsmg-details-published').prop('checked') ? 1 : 0,
			'x1'			: jQuery('#rsmg-x1').val(),
			'y1'			: jQuery('#rsmg-y1').val(),
			'x2'			: jQuery('#rsmg-x2').val(),
			'y2'			: jQuery('#rsmg-y2').val(),
			'w'				: jQuery('#rsmg-width').val(),
			'h'				: jQuery('#rsmg-height').val(),
			'admin_w'		: jQuery('#rsmg-admin-width').val(),
			'admin_h'		: jQuery('#rsmg-admin-height').val(),
			'filters'		: RSMediaGallery.Filters.buildFilterLink
		},
		beforeSend	: function() {
			// Hide buttons - need to save the request without interruptions
			jQuery('.rsmg_button_apply').hide();
			jQuery('.rsmg_button_save').hide();
			jQuery('.rsmg_button_cancel').hide();
		},
		success		: function(data) {

			// Show buttons
			jQuery('.rsmg_button_apply').show();
			jQuery('.rsmg_button_save').show();
			jQuery('.rsmg_button_cancel').show();

			if (typeof data == 'object') {
				if (data.success == 1) {

					var skipcache 	= Math.floor(Math.random() * 1000001),
						item		= data.item,
						img			= parent.find('img');

					// If effects filter exist for the item
					var filter = '';

					if (data.item.params.filters != '') {
						filter = 'filter/';
					}

					if (typeof data.item.params.filters != "undefined") {
						if (data.item.params.filters != '') {
							filter = 'filter/';
						}
					}

					img.attr('thumb-src', rsmgGetRoot() + '/components/com_rsmediagallery/assets/gallery/' + filter + item.filename + '?skipcache=' + skipcache);
					// Store data in image
					img.data('rsmg_data', {'admin_w': jQuery('#rsmg-admin-width').val(), 'admin_h': jQuery('#rsmg-admin-height').val()});

					if (item.published == 1) {
						// Show published
						parent.find('.rsmg-publish').removeClass('rsmg-publish-loading').removeClass('rsmg-unpublished').addClass('rsmg-published').find('.rsmg-text').html(rsmgGetLang('COM_RSMEDIAGALLERY_PUBLISHED'));
					} else {
						// Show unpublished
						parent.find('.rsmg-publish').removeClass('rsmg-publish-loading').removeClass('rsmg-published').addClass('rsmg-unpublished').find('.rsmg-text').html(rsmgGetLang('COM_RSMEDIAGALLERY_UNPUBLISHED'));
					}

					// Refresh tags
					parent.find('.rsmg-tags').attr('title', rsmgGetLang('COM_RSMEDIAGALLERY_BTN_TAGS_DESC') + escapeHTML(jQuery('#rsmg-details-tags').val()));

					// Close details
					if (!apply) {
                        rsmgCloseDetails();
						
						rsmgShowMessage(rsmgGetLang('COM_RSMEDIAGALLERY_ITEM_SAVED'), 'rsmg-success');
					} else {
						jQuery('#rsmg-save-result').addClass('rsmg-success alert alert-success').html(rsmgGetLang('COM_RSMEDIAGALLERY_CHANGES_APPLIED'));
					}
				} else {
					// Show the error message
					jQuery('#rsmg-save-result').addClass('rsmg-error alert alert-error').html(data.message);
				}
				
				if (jQuery('#rsmg-save-result').hasClass('alert')) {
					setTimeout(function() {
						jQuery('#rsmg-save-result').removeAttr('class').empty();
					}, 3000);
				}
			}
		}
	});
}

function rsmgCloseDetails() {
	jQuery('.rsmg-item-details').hide();
	jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container img').attr('src', jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container img').attr('thumb-src'));
	jQuery('.rsmg-details-thumb-container img').cropper().unbind('crop');
	jQuery('.rsmg-details-thumb-container img').cropper().unbind('ready');
	jQuery('.rsmg-details-thumb-container img').cropper('destroy');
	jQuery('.rsmg-details-thumb-container img').off('load');
	jQuery('.rsmg-details-thumb-preview').removeAttr('style');
	jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container img').removeAttr('style');
	rsmgUpdateTags();
	jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container .rsmg-loader-container').remove();
	jQuery('.rsmg-item.rsmg-edit-item').removeClass('rsmg-edit-item');
}

function rsmgSelectAll(elem, chk) {
	jQuery('.' + chk).each(function() {
		if (jQuery(elem).is(':checked')) {
			jQuery(this).prop('checked', true);
		} else {
			jQuery(this).prop('checked', false);
		}
	});
}

function rsmgFtpBuildTable(data, path) {
	var table			= jQuery('<table>', {
			'class': 'table table-striped table-condensed rsmg-folder-list-table'
		}),
		table_header	= '<th width="1%">' + rsmgGetLang('COM_RSMEDIAGALLERY_IMPORT_PREVIEW') + '</th>';

	table_header += '<th>' + rsmgGetLang('COM_RSMEDIAGALLERY_IMPORT_FILE') + '</th>';
	table_header += '<th width="23%">' + rsmgGetLang('COM_RSMEDIAGALLERY_IMPORT_DIMENSIONS') + '</th>';
	table_header += '<th width="8%" style="text-align:center">' + rsmgGetLang('COM_RSMEDIAGALLERY_IMPORT_SELECT') + '</th>';

	table.append(
		jQuery('<thead>').append(
			jQuery('<tr>').html(table_header)
		)
	);

	if (path) {
		var first_line = jQuery('<tr>');

		first_line.append(jQuery('<td>', {'style': 'text-align: center'}).append(
			jQuery('<a>', {'href': 'javascript:void(0)'}).bind('click', function() {
                rsmgFtpTask('navigate', (data.backpath.length > 0 ? data.backpath : ''));
			}).html('<i class="rsmg-icon-chevron-up"></i>')
		));
		first_line.append(jQuery('<td>').append(
			jQuery('<a>', {'href': 'javascript:void(0)'}).bind('click',function() {
                rsmgFtpTask('navigate', (data.backpath.length > 0 ? data.backpath : ''));
			}).html('..')
		));
		first_line.append(jQuery('<td>').html('&nbsp;'));
		first_line.append(jQuery('<td>', {'style': 'text-align: center'}).html('<input type="checkbox" onclick="rsmgSelectAll(jQuery(this), \'rsmg-select\')"/>'));

		table.append(first_line);
	}

	jQuery.each(data.folders, function(index, val) {
		var folders_line = jQuery('<tr>');

		folders_line.append(jQuery('<td>', {'style': 'text-align: center'}).append(jQuery('<a>', {'href': 'javascript:void(0)'}).bind('click', function() {
            rsmgFtpTask('navigate', val.path_relative);
		}).html('<i class="rsmg-icon-folder"></i>')));

		folders_line.append(jQuery('<td>').append(jQuery('<a>', {'href': 'javascript:void(0)'}).bind('click', function() {
            rsmgFtpTask('navigate', val.path_relative);
		}).html(val.name)));

		folders_line.append(jQuery('<td>').html('&nbsp;'));
		folders_line.append(jQuery('<td>', {'style': 'text-align: center'}).append(jQuery('<input>', {'type': 'checkbox', 'class': 'rsmg-select', 'value': val.name, 'name': 'sel[]'})));
		table.append(folders_line);
	});

	jQuery.each(data.images, function(index, val) {
		var images_line	= jQuery('<tr>'),
			link_image	= jQuery('<img>', {'width': val.width_30, 'height': val.height_30, 'alt': val.name, 'src': val.path_relative_thumb});

		if (typeof val.path_relative_src_thumb != 'undefined') {
			link_image.attr('data-src', val.path_relative_src_thumb);
			link_image.attr('data-rsimgloaded', '0');
		}

		images_line.append(jQuery('<td>', {'style': 'text-align:center'}).append(jQuery('<a>', {'href': rsmgGetRoot() + '/' + val.path_relative, 'target': '_blank', 'class': 'img-preview'}).html(link_image)));
		images_line.append(jQuery('<td>').append(jQuery('<a>', {'href': rsmgGetRoot() + '/' + val.path_relative, 'target': '_blank', 'class': 'img-preview'}).html(val.name)));
		images_line.append(jQuery('<td>').html(val.width + ' x ' + val.height));
		images_line.append(jQuery('<td>', {'style': 'text-align:center'}).append(jQuery('<input>', {'type': 'checkbox', 'class': 'rsmg-select', 'value': val.name, 'name': 'sel[]'})));

		table.append(images_line);
	});

	var input_path = jQuery('<input>', {'type': 'hidden', 'id': 'rsmg-basepath', 'value': path});

	jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content .rsmg-loader-container').remove();
	jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content').empty();
	jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content').append(table);
	jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content').append(input_path);

    rsmgInitListImages();
}

function rsmgInitListImages() {
	if (jQuery('[data-rsimgloaded="0"]').length) {
		var img_defer = jQuery('[data-rsimgloaded="0"]')[0];

		// Transform it in a jQuery object
		img_defer = jQuery(img_defer);

		img_defer.attr('data-rsimgloaded', '1');
		img_defer.load(function() {
            rsmgInitListImages();
		}).attr('src', img_defer.attr('data-src'));
	}
}

function rsmgFtpTask(task, path) {
	switch (task) {
		case 'navigate':
			jQuery.ajax({
				type		: 'POST',
				url			: 'index.php?option=com_rsmediagallery&controller=items&task=getimagesftp&format=raw',
				data		: {'path': path},
				dataType	: 'json',
				beforeSend	: function() {

					jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content').empty();

					// Append the loader as the last item in the list
					jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content').append('<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>');
				},
				success		: function(data) {
					jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content .rsmg-loader-container').remove();

                    rsmgFtpBuildTable(data, path);
				}
			});
			break;
	}
}

function rsmgSubmit(task) {
	switch (task) {
		case 'save':
            rsmgSaveDetails();
			return;
			break;

		case 'apply':
            rsmgSaveDetails(true);
			return;
			break;

		case 'cancel':
            rsmgCloseDetails();
			return;
			break;

		case 'upload':
			jQuery('#rsmg-modal-upload').modal('show');

			jQuery('#rsmg-modal-upload').on('hidden.bs.modal', function() {
				jQuery('#rsmg-modal-upload #rsmg-add-tags-text').val('');
				jQuery('#rsmg-modal-upload #rsmg-add-published').prop('checked', false);
				jQuery('#rsmg-modal-upload #rsmg-add-free-ratio').prop('checked', false);
				jQuery('#rsmg-modal-upload .rsmg-add-results').empty();
				jQuery('#rsmg-modal-upload #rsmg-clear-results:not(.rsmg-none)').addClass('rsmg-none');
			});

			return;
			break;

		case 'import':
			jQuery('#rsmg-modal-upload-ftp').on('shown.bs.modal', function() {
                rsmgFtpTask('navigate', '');
			});
			jQuery('#rsmg-modal-upload-ftp').on('hidden.bs.modal', function() {
				jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content').empty();
				jQuery('#rsmg-modal-upload-ftp #rsmg-add-ftp-published').prop('checked', false);
				jQuery('#rsmg-modal-upload-ftp #rsmg-add-ftp-free-ratio').prop('checked', false);
				jQuery('#rsmg-modal-upload-ftp .rsmg-add-results').empty();
				jQuery('#rsmg-modal-upload-ftp #rsmg-clear-results:not(.rsmg-none)').addClass('rsmg-none');
			});

			jQuery('#rsmg-modal-upload-ftp').modal('show');

			return;
            break;
	}

	var children = jQuery('ul.rsmg-items li.rsmg-item.ui-selected').children('input[name="cid[]"]');

	if (children.length == 0) {
		jQuery('#rsmg-modal-please-select').modal('show');
	} else {
		var cid					= new Array(),
            parent				= children.parents('li.rsmg-item'),
			published_cid		= new Array(),
			published_parent	= children.parent().find('.rsmg-publish.rsmg-published').parents('li.rsmg-item'),
			unpublished_cid		= new Array(),
			unpublished_parent	= children.parent().find('.rsmg-publish.rsmg-unpublished').parents('li.rsmg-item');

		children.each(function(index, el) {
			cid.push(jQuery(el).val());
			
			if (jQuery(el).parent().find('.rsmg-publish').hasClass('rsmg-published')) {
				published_cid.push(jQuery(el).val());
			} else if (jQuery(el).parent().find('.rsmg-publish').hasClass('rsmg-unpublished')) {
				unpublished_cid.push(jQuery(el).val());
			}
		});

		switch (task) {
			case 'delete':
				// Remove items from list
                rsmgDeleteItems(parent, cid);
				break;

			case 'publish':
			    // Publish items
				if (unpublished_parent.find('.rsmg-publish').hasClass('rsmg-publish-loading')) {
					return false;
				}

                rsmgPublishItems(unpublished_cid, function() {
                        // Callback - long chain here to unpublish items
						unpublished_parent.find('.rsmg-publish').find('.rsmg-text').html(rsmgGetLang('COM_RSMEDIAGALLERY_UNPUBLISHED'));
						unpublished_parent.find('.rsmg-publish').addClass('rsmg-published');
						unpublished_parent.find('.rsmg-publish').removeClass('rsmg-publish-loading');
                    },
                    function() {
						unpublished_parent.find('.rsmg-publish').removeClass('rsmg-unpublished');
						unpublished_parent.find('.rsmg-publish').addClass('rsmg-publish-loading');
						unpublished_parent.find('.rsmg-publish').removeClass('rsmg-published');
                    }
                );
				break;

			case 'unpublish':
			    // Unpublish items
				if (published_parent.find('.rsmg-publish').hasClass('rsmg-publish-loading')) {
					return false;
				}

                rsmgUnpublishItems(published_cid, function() {
                        // Callback - long chain here to unpublish items
						published_parent.find('.rsmg-publish').find('.rsmg-text').html(rsmgGetLang('COM_RSMEDIAGALLERY_UNPUBLISHED'));
						published_parent.find('.rsmg-publish').addClass('rsmg-unpublished');
						published_parent.find('.rsmg-publish').removeClass('rsmg-publish-loading');
                    },
                    function() {
						published_parent.find('.rsmg-publish').removeClass('rsmg-published');
						published_parent.find('.rsmg-publish').addClass('rsmg-publish-loading');
						published_parent.find('.rsmg-publish').removeClass('rsmg-unpublished');
                    }
                );
				break;

			case 'tag':
				// Tag button
				jQuery('#rsmg-modal-tag').modal('show');

				jQuery('#rsmg-modal-tag-save').one('click', function() {
					if (jQuery('#rsmg-tags-text').val().trim().length == 0) {
						jQuery('#rsmg-tags-text').val('');
						jQuery('#rsmg-tags-text-error').show('fade', {}, 600);

						setTimeout(function() {
							jQuery('#rsmg-tags-text-error').hide('fade', {}, 600);
						}, 3000);

						return;
					}

					jQuery('#rsmg-tags-text-error').hide();
					jQuery('#rsmg-modal-tag').modal('hide');

					var select_all = jQuery('#rsmg-select-all').attr('rel') == 1 ? 1 : 0;

					jQuery.ajax({
						type	: 'POST',
						url		: 'index.php?option=com_rsmediagallery&controller=items&task=' + (jQuery('#rsmg-action0:checked').length > 0 ? 'tagitems' : 'untagitems') + '&format=raw',
						data	: {'cid[]': cid, 'tags': jQuery('#rsmg-tags-text').val(), 'selectall': select_all},
						success	: function() {
							jQuery('#rsmg-tags-text').val('');

							var message = jQuery('#rsmg-action0:checked').length > 0 ? rsmgGetLang('COM_RSMEDIAGALLERY_TAGS_HAVE_BEEN_ADDED') : rsmgGetLang('COM_RSMEDIAGALLERY_TAGS_HAVE_BEEN_REMOVED');

                            rsmgShowMessage(message, 'rsmg-success');

							rsmgGetItems(true);
						}
					});
				});
				break;
		}
	}
}

function rsmgAddToGallery() {
	var items_selected = [];

	jQuery('.rsmg-select').each(function() {
		if (jQuery(this).is(':checked')) {
			items_selected.push(jQuery(this).val());
		}
	});

	var base_path	= jQuery('#rsmg-basepath').val(),
		tags 	 	= jQuery('#rsmg-add-ftp-tags-text').val(),
		published 	= jQuery('#rsmg-add-ftp-published').prop('checked') ? 1 : 0,
		free_ratio	= jQuery('#rsmg-add-ftp-free-ratio').prop('checked') ? 1 : 0;

	if (items_selected.length > 0) {
		jQuery.ajax({
			type		: 'POST',
			url			: 'index.php?option=com_rsmediagallery&controller=items&task=addImagesFtp&format=raw',
			data		: {'basepath': base_path, 'items[]': items_selected, 'tags': tags, 'published': published, 'freeratio': free_ratio},
			dataType	: 'json',
			beforeSend	: function() {
				jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content .table').fadeTo('fast', 0.4);
				jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content .rsmg-loader-container').show();

				jQuery('#rsmg-modal-upload-ftp-add').addClass('rsmg-none');
				jQuery('#rsmg-modal-upload-ftp-cancel').text(rsmgGetLang('COM_RSMEDIAGALLERY_PLEASE_WAIT'));
				jQuery('#rsmg-modal-upload-ftp-cancel').attr(rsmgGetBootstrapElement('data', 'dismiss'), '');
				jQuery('#rsmg-modal-upload-ftp-cancel').attr('onclick', 'return false;');
			},
			success		: function(data) {
				jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content .rsmg-loader-container').hide();
				jQuery('#rsmg-modal-upload-ftp .rsmg-ajax-content .table').fadeTo('fast', 1);

				jQuery('.rsmg-select').each(function() {
					if (jQuery(this).is(':checked')) {
						jQuery(this).prop('checked', false);
					}
				});

				jQuery.each(data, function(index, val) {
					var li		= jQuery('<li>', {'class': val.error == 1 ? 'rsmg-error alert alert-error' : 'rsmg-success alert alert-success'}).html(val.message),
						icon	= jQuery('<span>', {'class': val.error == 1 ? 'rsmg-icon-times-circle' : 'rsmg-icon-check-circle'});

					li.prepend(icon);

					jQuery('#rsmg-modal-upload-ftp .rsmg-add-results').prepend(li);
					jQuery('#rsmg-modal-upload-ftp .rsmg-add-results + .rsmg-button').removeClass('rsmg-none');
				});

				jQuery('#rsmg-modal-upload-ftp-add').removeClass('rsmg-none');
				jQuery('#rsmg-modal-upload-ftp-cancel').text(rsmgGetLang('COM_RSMEDIAGALLERY_CLOSE'));
				jQuery('#rsmg-modal-upload-ftp-cancel').attr(rsmgGetBootstrapElement('data', 'dismiss'), 'modal');
				jQuery('#rsmg-modal-upload-ftp-cancel').attr('onclick', 'rsmgGetItems(true);');

				var message = rsmgGetLang('COM_RSMEDIAGALLERY_IMPORT_FINAL_SUCCESS');

                rsmgShowMessage(message, 'rsmg-success');
			}
		});
	} else {
		alert(rsmgGetLang('COM_RSMEDIAGALLERY_IMPORT_SELECT_ITEMS'));
	}
}

function rsmgClearResults() {
	jQuery('.rsmg-add-results + #rsmg-clear-results:not(.rsmg-none)').prev('.rsmg-add-results').empty();
	jQuery('.rsmg-add-results + #rsmg-clear-results:not(.rsmg-none)').addClass('rsmg-none');
}

function rsmgShowSelected() {
	var selected = jQuery('.rsmg-items').children('.ui-selected').length,
		all 	 = (typeof jQuery('.rsmg-load-more').attr('rel') !== 'undefined') ? parseInt(jQuery('.rsmg-load-more').attr('rel')) + jQuery('.rsmg-items').children('li').length : jQuery('.rsmg-items').children('li').length;

	// If all items are selected
	if (jQuery('#rsmg-select-all').attr('rel') && jQuery('#rsmg-select-all').attr('rel') == 1) {
		selected = all;
	}

	var message = rsmgGetLang('COM_RSMEDIAGALLERY_SELECTED_ITEMS').replace('%d', selected).replace('%d', all);

    rsmgShowMessage(message, 'rsmg_selected', true);
}

function rsmgShowMessage(message, classname, persist) {
	jQuery('.rsmg-info').empty();
	jQuery('.rsmg-info').show();

	var p		= jQuery('<p>', {'class': classname}).html(message).hide(),
		icon	= (classname == 'rsmg-success') ? jQuery('<span>', {'class': 'rsmg-icon-check-circle'}) : '';

	p.prepend(icon);
	jQuery('.rsmg-info').append(p.show('fade', {}, 600));

	if (!persist) {
		setTimeout(function() {
			p.hide('fade', function() { jQuery(this).remove(); }, 600);
		}, 10000);
	}
}

function rsmgChangeAspectRatio() {

	RSMediaGallery.Loader.add();

	var details_thumb_img   	= jQuery('.rsmg-details-thumb-container img'),
		details_thumb_preview	= jQuery('.rsmg-details-thumb-preview');
		free_aspect 	    	= jQuery('#rsmg-details-free-aspect').prop('checked'),
		ratio 			    	= free_aspect ? NaN : 4/3,
		thumb_ratio         	= Math.round((details_thumb_img.attr('original-width') / jQuery('.rsmg-details-thumb-container').width()) * 100) / 100,
		cropper_options			= RSMediaGallery.Cropper.options,
		selection 		    	= {
			x1      : Math.round(jQuery('#rsmg-x1').val() * thumb_ratio),
			y1      : Math.round(jQuery('#rsmg-y1').val() * thumb_ratio),
			x2      : Math.round((jQuery('#rsmg-x1').val() + jQuery('#rsmg-width').val()) * thumb_ratio),
			y2      : Math.round((jQuery('#rsmg-y1').val() + jQuery('#rsmg-height').val()) * thumb_ratio),
			width   : Math.round(jQuery('#rsmg-width').val() * thumb_ratio),
			height  : Math.round(jQuery('#rsmg-height').val() * thumb_ratio)
		},
		width 			    	= details_thumb_img.attr('original-width'),
		height			    	= details_thumb_img.attr('original-height'),
		computed_width			= selection.width,
		computed_height			= selection.height;

	if (free_aspect) {

		if (selection.width / selection.height != 4/3) {
			computed_height = Math.round(computed_width * 3/4);

			if (computed_height <= height) {
				if (selection.y1 + computed_height <= height) {
					selection.y2 = selection.y1 + computed_height;
				} else {
					while ((selection.y1 > -1) && (selection.y1 + computed_height > height)) {
						selection.y1--;
					}
					selection.y2 = selection.y1 + computed_height;
				}
			} else {
				computed_width = Math.round(computed_height * 4/3);

				if (computed_width <= width) {
					if (selection.x1 + computed_width <= width) {
						selection.x2 = selection.x1 + computed_width;
					} else {
						while ((selection.x1 > -1) && (selection.x1 + computed_width > width)) {
							selection.x1--;
						}
						selection.x2 = selection.x1 + computed_width;
					}
				} else {
					computed_width  = 4;
					computed_height = 3;

					selection.x1 = 0;
					selection.x2 = 4;
					selection.y1 = 0;
					selection.y2 = 3;
				}
			}
		}
	} else {
		if (computed_width > computed_height) {
			computed_width = Math.round(computed_height * 4/3);
		} else {
			computed_height = Math.round(computed_width * 3/4);
		}
	}

	var new_values = {
		x		: selection.x1,
		y		: selection.y1,
		width	: computed_width,
		height	: computed_height
	};
	
	cropper_options.aspectRatio	= ratio;
	
	details_thumb_img.cropper().unbind('crop');
	details_thumb_img.cropper().unbind('ready');
	details_thumb_img.cropper('destroy');
	
	details_thumb_preview.removeAttr('style');

	rsmg_img_cropper = details_thumb_img.cropper(cropper_options);

	RSMediaGallery.Cropper.onChange(rsmg_img_cropper);
	RSMediaGallery.Cropper.onInit(rsmg_img_cropper, new_values, true);
}

function rsmgSaveThumbnailPositions(selection) {
	jQuery('#rsmg-x1').val(selection.x1);
	jQuery('#rsmg-y1').val(selection.y1);
	jQuery('#rsmg-x2').val(selection.x2);
	jQuery('#rsmg-y2').val(selection.y2);
	jQuery('#rsmg-width').val(selection.width);
	jQuery('#rsmg-height').val(selection.height);
}

function rsmgUpdateTags() {
    var item    = jQuery('.rsmg-item.rsmg-edit-item'),
        cid     = item.find('input[name="cid[]"]').val();

    jQuery.ajax({
        type		: 'POST',
        url			: 'index.php?option=com_rsmediagallery&controller=items&task=getitemtags&format=raw',
        data		: {
            'cid' : cid
        },
        dataType	: 'json',
        success		: function(data) {
            if (typeof data == 'object') {

                var item_tags       = data.data.tags ? data.data.tags.replaceAll(',', ', ') : rsmgGetLang('COM_RSMEDIAGALLERY_BTN_NO_TAGS_DESC'),
                    item_tags_title = data.data.tags ? '<span class="rsmg-popover-header">' + rsmgGetLang('COM_RSMEDIAGALLERY_BTN_TAGS_DESC') + '</span>' : '';

				rsmgDestroyPopover();
                item.find('.rsmg-action-button.rsmg-tags').attr(rsmgGetBootstrapElement('data', 'content'), item_tags_title + item_tags);
                item.find('.rsmg-action-button.rsmg-tags').attr('title', '');
				rsmgInitPopover();
            }
        }
    });
}

// Filter effects

var RSMediaGallery = {};

RSMediaGallery.Cropper = {
	options		: {
		aspectRatio					: 4/3,
		responsive					: true,
		restore						: true,
		checkCrossOrigin			: true,
		checkOrientation			: true,
		modal						: true,
		guides						: true,
		center						: true,
		highlight					: true,
		background					: false,
		autoCrop					: true,
		autoCropArea				: 1,
		movable						: false,
		viewMode					: 2,
		rotatable					: false,
		scalable					: false,
		zoomable					: false,
		zoomOnTouch					: false,
		zoomOnWheel					: false,
		cropBoxMovable				: true,
		cropBoxResizable			: true,
		toggleDragModeOnDblclick	: false,
		preview						: '.rsmg-details-thumb-preview'
	},
	onChange	: function(cropper) {
		var timer		= null,
			selection	= {},
			ratio		= Math.round(jQuery('.rsmg-details-thumb-container').width() / jQuery('.rsmg-details-thumb-container img').attr('original-width') * 100) / 100;

		cropper.on({
			crop : function(e) {

				// Crop delay
				if (timer != null) clearTimeout(timer);

				timer = setTimeout(function() {
					selection.x1        = Math.round(e.detail.x * ratio);
					selection.x2        = Math.round((e.detail.x + e.detail.width) * ratio);
					selection.y1        = Math.round(e.detail.y * ratio);
					selection.y2        = Math.round((e.detail.y + e.detail.height) * ratio);
					selection.width     = Math.round(e.detail.width * ratio);
					selection.height    = Math.round(e.detail.height * ratio);

					jQuery('#rsmg-selection-res').empty().append(Math.round(e.detail.width) + ' x ' + Math.round(e.detail.height));
					jQuery('#rsmg-selection-ratio').empty().append((e.detail.width / e.detail.height).toFixed(2));

                    rsmgCalculateThumbnail(selection);
					rsmgSaveThumbnailPositions(selection);
				}, 100);
			}
		});
	},
	onInit		: function(cropper, values) {
		
		if (rsmg_jversion == 4) {
			cropper.on({
				ready : function() {
					cropper.cropper('setData', values);
					
					setTimeout(function() {
						RSMediaGallery.Loader.remove();
					}, 550);
				}
			});
		} else {
			jQuery('.rsmg-details-thumb-container img').on('load', function() {
				setTimeout(function() {
					cropper.cropper('setData', values);
					
					setTimeout(function() {
						RSMediaGallery.Loader.remove();
					}, 550);
				}, 100);
			});
		}
	}
};

RSMediaGallery.Loader = {
	add		: function() {
		var details_img_container	= jQuery('.rsmg-details-image'),
			details_thumb_container	= jQuery('.rsmg-details-thumb-container'),
			details_thumb_info		= jQuery('.rsmg-details-thumb-info');

		if (details_img_container.find('.rsmg-loader-container').length == 0) {
			details_thumb_container.addClass('rsmg-hidden');
			details_thumb_info.addClass('rsmg-hidden');
			details_img_container.append('<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>');
		}
	},
	remove	: function() {
		var details_img_container	= jQuery('.rsmg-details-image'),
			details_thumb_container	= jQuery('.rsmg-details-thumb-container'),
			details_thumb_info		= jQuery('.rsmg-details-thumb-info');

		if (details_img_container.find('.rsmg-loader-container').length != 0) {
			details_thumb_container.removeClass('rsmg-hidden');
			details_thumb_info.removeClass('rsmg-hidden');
			details_img_container.find('.rsmg-loader-container').remove();
		}
	}
};

RSMediaGallery.Filters = {
	buildFilterLink   	: '',
	selectedFilters   	: [],
	attributesFilters 	: {},
	predefinedFilters   : ['sepia','amaro','nashville','seventyseven','highcontrast','light','vintage','hot','blueseasoning','stretch','greenhornet','grounded','coldbreeze','diva','lifeonmars','morning','oldphoto','deepfocus','wornvintage','mist','overblown'],

	getFilters		  	: function() {
		jQuery.each(this.predefinedFilters, function(index, val) {
			var is_selected = jQuery('.rsmg-effect-' + val).hasClass('selected');

			if (is_selected) {
				if (!RSMediaGallery.Helpers.inArray(val, RSMediaGallery.Filters.selectedFilters)) {
					RSMediaGallery.Filters.selectedFilters.push(val);
				}
			} else {
				if (RSMediaGallery.Helpers.inArray(val, RSMediaGallery.Filters.selectedFilters)) {
					RSMediaGallery.Helpers.removeFromArray(val, RSMediaGallery.Filters.selectedFilters, 'value');
				}
			}
		});

		jQuery('.rsmg-effect-filters input').each(function() {
			var filter			= (jQuery(this).attr('type') == 'checkbox') ? jQuery(this).val() : jQuery(this).attr('data-effect'),
				filter_value	= jQuery(this).val();

			if ((jQuery(this).attr('type') == 'checkbox' && jQuery(this).is(':checked')) || (jQuery(this).attr('type') == 'number' && filter_value != '0')) {
				if (!RSMediaGallery.Helpers.inArray(filter, RSMediaGallery.Filters.selectedFilters)) {
					if (filter == 'pixelate' && filter_value == '1') {
						RSMediaGallery.Helpers.removeFromArray(filter, RSMediaGallery.Filters.selectedFilters, 'value');
					} else {
						RSMediaGallery.Filters.selectedFilters.push(filter);
					}
				} else if (filter == 'pixelate' && filter_value == '1') {
					RSMediaGallery.Helpers.removeFromArray(filter, RSMediaGallery.Filters.selectedFilters, 'value');
				}
			} else {
				RSMediaGallery.Helpers.removeFromArray(filter, RSMediaGallery.Filters.selectedFilters, 'value');
			}
		});
	},

	getAttributes	: function(filter) {
		if (jQuery('.rsmg-effect-filters .rsmg-effect-' + filter + '-value').length) {
			var val_attr = jQuery('.rsmg-effect-filters .rsmg-effect-' + filter + '-value').val();

			this.attributesFilters[filter] = '-a-' + val_attr;
		}
	},

	setFilterLink	: function() {
		RSMediaGallery.Filters.getFilters();

		var tmp_link = 'filters=';

		jQuery.each(this.selectedFilters, function(index, filter) {
			var tmp_attr = '';

			RSMediaGallery.Filters.getAttributes(filter);

			if (RSMediaGallery.Filters.attributesFilters[filter]) {
				tmp_attr = RSMediaGallery.Filters.attributesFilters[filter];
			}

			tmp_link = tmp_link + filter + tmp_attr + '-x-';
		});

		if (tmp_link != 'filters=') {
			this.buildFilterLink = tmp_link.replace(new RegExp('-x-$'), '');
		} else {
			this.buildFilterLink = '';
		}
	},

	resetFilters	: function(init) {
		var filters_container = '.rsmg-effect-filters';

		jQuery(filters_container + ' input:checkbox').each(function() {
			jQuery(this).prop('checked', false);
		});

		jQuery(filters_container + ' input[type="number"]').each(function() {
			if (jQuery(this).hasClass('rsmg-effect-pixelate-value')) {
				jQuery(this).val(1);
			} else {
				jQuery(this).val(0);
			}
		});

		if (init) {
			RSMediaGallery.Filters.initFilterSliders();
			RSMediaGallery.Filters.applyFilters('none');
		}
	},

	setFiltersValues : function(data) {

		// Reset effects filters
		RSMediaGallery.Filters.resetFilters(false);
		RSMediaGallery.Filters.resetPredefined();

		if (typeof data !== 'undefined' && data != '') {
			var filters			= data.split('-x-'),
				special_filters	= ['brightness', 'contrast', 'pixelate'];

			jQuery.each(filters, function(index, filter) {
				var filter_data = filter.split('-a-');

				filter = filter_data[0];

				if (RSMediaGallery.Helpers.inArray(filter, RSMediaGallery.Filters.predefinedFilters)) {
					RSMediaGallery.Filters.selectPredefined(filter);
				}

				if (RSMediaGallery.Helpers.inArray(filter, special_filters)) {
					jQuery('.rsmg-effect-filters .rsmg-effect-' + filter + '-value').val(filter_data[1]);
				} else {
					jQuery('.rsmg-effect-filters #rsmg-effect-' + filter).prop('checked', true);
				}
			});
		}

		RSMediaGallery.Filters.initFilterSliders();
	},

	selectPredefined : function(selected) {
		jQuery('.rsmg-effect-predefined-filters a').each(function() {

			var html_class = jQuery(this).hasClass('rsmg-effect-' + selected);

			if (html_class) {
				if (!jQuery(this).hasClass('selected')) {
					jQuery(this).addClass('selected');
				}
			} else {
				if (jQuery(this).hasClass('selected')) {
					jQuery(this).removeClass('selected');
				}
			}
		});
	},

	resetPredefined : function() {
		jQuery('.rsmg-effect-predefined-filters a').each(function() {
			if (jQuery(this).hasClass('selected')) {
				jQuery(this).removeClass('selected');
				RSMediaGallery.Filters.applyFilters('none');
			}
		});
	},

	reorderFilters : function(filters, predefined) {
		if (filters != '') {

			filters = filters.replace('filters=', '');

			var filters_array = filters.split('-x-');

			jQuery(filters_array).each(function(index, val) {
				filters_array[index] = val.replace(new RegExp('-a-(-*[0-9])+$'), '');
			});

			if (predefined != 'none' && jQuery.inArray(predefined, filters_array) != -1) {
				filters = filters.replace(predefined + '-x-', '');
				filters = filters.replace('-x-' + predefined, '');
				filters = filters.replace(predefined, '');
				filters = filters != '' ? predefined + '-x-' + filters : predefined;
			} else {
				jQuery.each(this.predefinedFilters, function(index, val) {
					if (jQuery.inArray(val, filters_array) != -1) {
						filters = filters.replace(val + '-x-', '');
						filters = filters.replace('-x-' + val, '');
						filters = filters.replace(val, '');
						filters = filters != '' ? val + '-x-' + filters : val;
					}
				});
			}

			filters = 'filters=' + filters;
		}

		return filters;
	},

	applyFilters	: function(predefined) {
		
		RSMediaGallery.Loader.add();
		
		if (predefined != 'none') {
			this.selectPredefined(predefined);
		}

		RSMediaGallery.Filters.setFilterLink();

		this.buildFilterLink = this.reorderFilters(this.buildFilterLink, predefined);

		var thumb_img				= jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container img'),
			thumb_container			= jQuery('.rsmg-item.rsmg-edit-item .rsmg-thumb-container'),
			details_thumb_img		= jQuery('.rsmg-details-thumb-container img'),
			old_src					= thumb_img.attr('original-src'),
			thumb_ratio         	= Math.round((details_thumb_img.attr('original-width') / jQuery('.rsmg-details-thumb-container').width()) * 100) / 100,
			selection 		   		= {
				x		: Math.round(jQuery('#rsmg-x1').val() * thumb_ratio),
				y		: Math.round(jQuery('#rsmg-y1').val() * thumb_ratio),
				width   : Math.round(jQuery('#rsmg-width').val() * thumb_ratio),
				height  : Math.round(jQuery('#rsmg-height').val() * thumb_ratio)
			},
			cropper_options			= RSMediaGallery.Cropper.options;

		cropper_options.aspectRatio = jQuery('#rsmg-details-free-aspect').prop('checked') ? NaN : 4/3;

		if (RSMediaGallery.Filters.buildFilterLink != '') {
			var thumb_res_w         = Math.round(thumb_img.attr('original-width')),
				thumb_res_h         = Math.round(thumb_img.attr('original-height')),

				details_thumb_res_w	= Math.round(details_thumb_img.attr('original-width')),
				details_thumb_res_h	= Math.round(details_thumb_img.attr('original-height')),

				file  		        = old_src.split('/');

			file = file[(file.length - 1)];
			
			// Test if can apply filters
			jQuery.ajax({
				type		: 'POST',
				url			: 'index.php?option=com_rsmediagallery&controller=items&task=checkMemory&format=raw',
				dataType	: 'json',
				data		: {'file': file},
				beforeSend	: function () {

					// Loader
					if (thumb_container.find('.rsmg-loader-container').length == 0) {
						thumb_container.append('<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>');
					}
				},
				success     : function (data) {
					if (data.status) {
						selection = {
							x		: Math.round(jQuery('#rsmg-x1').val() * thumb_ratio),
							y		: Math.round(jQuery('#rsmg-y1').val() * thumb_ratio),
							width   : Math.round(jQuery('#rsmg-width').val() * thumb_ratio),
							height  : Math.round(jQuery('#rsmg-height').val() * thumb_ratio)
						};

						// Change thumb
						var new_thumb_src = 'index.php?option=com_rsmediagallery&controller=items&task=buildFilterThumb&resolution=' + thumb_res_w + 'x' + thumb_res_h + '&file=' + file + '&';

						new_thumb_src += RSMediaGallery.Filters.buildFilterLink;
						thumb_img.attr('src', new_thumb_src);

						// Change details thumb
						var new_details_thumb_src = 'index.php?option=com_rsmediagallery&controller=items&task=buildFilterThumb&resolution=' + details_thumb_res_w + 'x' + details_thumb_res_h + '&file=' + file + '&';

						new_details_thumb_src += RSMediaGallery.Filters.buildFilterLink;
						
						details_thumb_img.cropper().unbind('crop');
						details_thumb_img.cropper().unbind('ready');
						details_thumb_img.cropper('destroy');
						
						details_thumb_img.attr('src', new_details_thumb_src);
						
						rsmg_img_cropper = details_thumb_img.cropper(cropper_options); // Cropping has been initialized

						RSMediaGallery.Cropper.onChange(rsmg_img_cropper);
						RSMediaGallery.Cropper.onInit(rsmg_img_cropper, selection, true);
					} else {
						alert(rsmgGetLang('COM_RSMEDIAGALLERY_ERROR_FILTER_MEMORY_LIMIT_VALUE'));
					}
				}
			});
		} else {

			// Restore to default
			if (thumb_img.attr('src') != old_src) {
				thumb_img.attr('src', old_src);
			}

			details_thumb_img.cropper().unbind('crop');
			details_thumb_img.cropper().unbind('ready');
			details_thumb_img.cropper('destroy');
			
			details_thumb_img.attr('src', old_src);

			rsmg_img_cropper = details_thumb_img.cropper(cropper_options); // Cropping has been initialized

			RSMediaGallery.Cropper.onChange(rsmg_img_cropper);
			RSMediaGallery.Cropper.onInit(rsmg_img_cropper, selection, true);
		}
	},

	initFilterSliders : function() {
		jQuery('.rsmg-effect-brightness-value').bind('blur', function() {
			RSMediaGallery.Filters.applyFilters('none');
		});

		jQuery('#rsmg-brightness').slider({
			min		: -255,
			max		: 255,
			value	: jQuery('.rsmg-effect-filters .rsmg-effect-brightness-value').val(),
			step	: 5,
			slide	: function(event, ui) {
				jQuery('.rsmg-effect-filters .rsmg-effect-brightness-value').val(ui.value);
				jQuery('.rsmg-effect-filters .rsmg-effect-brightness-value').attr('value', ui.value);
			},
			stop	: function() {
				RSMediaGallery.Filters.applyFilters('none');
			}
		});

		jQuery('.rsmg-effect-contrast-value').bind('blur', function() {
			RSMediaGallery.Filters.applyFilters('none');
		});

		jQuery('#rsmg-contrast').slider({
			min		: -100,
			max		: 100,
			value	: jQuery('.rsmg-effect-filters .rsmg-effect-contrast-value').val(),
			step	: 1,
			slide	: function(event, ui) {
				jQuery('.rsmg-effect-filters .rsmg-effect-contrast-value').val(ui.value);
			},
			stop	: function() {
				RSMediaGallery.Filters.applyFilters('none');
			}
		});

		jQuery('.rsmg-effect-pixelate-value').bind('blur', function() {
			RSMediaGallery.Filters.applyFilters('none');
		});

		jQuery('#rsmg-pixelate').slider({
			min		: 1,
			max		: 10,
			value	: jQuery('.rsmg-effect-filters .rsmg-effect-pixelate-value').val(),
			step	: 1,
			slide	: function(event, ui) {
				jQuery('.rsmg-effect-filters .rsmg-effect-pixelate-value').val(ui.value);
			},
			stop	: function() {
				RSMediaGallery.Filters.applyFilters('none');
			}
		});
	},

	changeSlider : function(effect, entered_value) {
		var min_max_effects	= {
				smooth		: [-8, 8],
				pixelate	: [1, 10],
				alpha		: [-127, 127]
			},
			error_text		= rsmgGetLang('COM_RSMEDIAGALLERY_ERROR_FILTER_VALUE');

		error_text = error_text.replace('%s', effect);

		if (min_max_effects[effect]) {
			if (entered_value > min_max_effects[effect][0] && entered_value < min_max_effects[effect][1]) {
				jQuery('#rsmg-' + effect).slider('value', entered_value);
			} else {
				entered_value = (effect == 'pixelate' ? min_max_effects[effect][0] : 0);
				jQuery('.rsmg-effect-' + effect + '-value').val(entered_value);
				jQuery('#rsmg-' + effect).slider('value', entered_value);

				alert(error_text);
			}
		} else {
			if (entered_value > -255 && entered_value < 255) {
				jQuery('#rsmg-' + effect).slider('value', entered_value);
			} else {
				jQuery('.rsmg-effect-' + effect + '-value').val(0);
				jQuery('#rsmg-' + effect).slider('value', 0);

				alert(error_text);
			}
		}
	}
};

RSMediaGallery.Helpers = {
	isNumber		: function(input, evt) {
		var char_code	= (evt.which) ? evt.which : evt.keyCode,
			accept		= true;

		if (char_code != 8 && char_code > 31 && (char_code < 48 || char_code > 57) && (char_code < 96 || char_code > 105)) {
			if (char_code == 46 || char_code == 173 || char_code == 109) {
				accept = true;
			} else {
				accept = false;
			}
		}
		return accept;
	},
	inArray			: function(needle, haystack) {
		var length = haystack.length;

		for (var i = 0; i < length; i++) {
			if (haystack[i] == needle) return true;
		}
		return false;
	},
	removeFromArray	: function(val, array, type) {
		var index = (type == 'value') ? array.indexOf(val) : val;

		if (index > -1) {
			array.splice(index, 1);
		}

		return array;
	}
};

RSMediaGallery.Tags = {
	showAllTags			: function(use) {
		if (typeof use == 'undefined') {
			use = false;
		}

		if (use) {
			jQuery('#rsmg-modal-all-tags-use, #rsmg-modal-all-tags-remove').removeClass('rsmg-hidden');
		} else if (!jQuery('#rsmg-modal-all-tags-use, #rsmg-modal-all-tags-remove').hasClass('rsmg-hidden')) {
			jQuery('#rsmg-modal-all-tags-use, #rsmg-modal-all-tags-remove').addClass('rsmg-hidden');
		}

		RSMediaGallery.Tags.getAllTags(jQuery('#rsmg-modal-all-tags .modal-body'), use);
        jQuery('#rsmg-modal-all-tags').modal('show');
	},

	getAllTags			: function(container, use) {
		jQuery.ajax({
			type		: 'POST',
			url			: 'index.php?option=com_rsmediagallery&controller=items&task=getAllTags',
			dataType	: 'json',
			beforeSend	: function() {
				container.empty();
				container.append('<div class="rsmg-loader-container"><div class="rsmg-loader"></div></div>');
			},
			success		: function(response) {
				container.find('.rsmg-loader-container').remove();

				if (response.success) {
					var tags_container	= jQuery('<div class="rsmg-all-tags">'),
						list			= jQuery('<ul>');

					jQuery.each(response.data.tags, function(key, value) {
						var li = jQuery('<li>');

						if (use) {
							var is_used = RSMediaGallery.Helpers.inArray(value, RSMediaGallery.Tags.getPhotoTags());

							li.append('<input type="checkbox" class="rsmg-use-tags" value="' + value + '" ' + (is_used ? 'checked="checked"' : '') + '/> ' + value);
						} else {
							li.append(value);
						}

						list.append(li);
					});

					if (list.find('li').length > 0) {
						container.append(tags_container.append(list));
					} else {
						container.append(rsmgGetLang('COM_RSMEDIAGALLERY_NO_TAGS'));
					}
				}
			}
		});
	},

	getPhotoTags		: function() {
		var photo_tags	= jQuery('#rsmg-details-tags').val().split(','),
			return_tags	= new Array();

		jQuery.each(photo_tags, function(key, tag) {
			tag = tag.trim();

			if (tag != '') {
				return_tags.push(tag);
			}
		});

		return return_tags;
	},

	useSelectedTags		: function() {
		var tags_container	= jQuery('#rsmg-details-tags'),
			to_use_tags		= jQuery('.rsmg-all-tags').find('.rsmg-use-tags:checked');

		if (to_use_tags.length) {
			var photo_tags		= this.getPhotoTags(),
				new_photo_tags	= new Array();

			// Get the old tags
			jQuery.each(photo_tags, function(key, tag) {
				new_photo_tags.push(tag.trim());
			});

			// Set the new tags
			jQuery.each(to_use_tags, function(key, tag) {
				tag = jQuery(tag).val();
				if (!RSMediaGallery.Helpers.inArray(tag, new_photo_tags)) {
					new_photo_tags.push(tag.trim());
				}
			});

			// Put the tags in the specific textarea
			tags_container.val(new_photo_tags.join(', '));
		} else {
			alert(rsmgGetLang('COM_RSMEDIAGALLERY_NO_TAGS_SELCTED'));
		}
	},

	removeSelectedTags	: function() {
		var tags_container	= jQuery('#rsmg-details-tags'),
			to_remove_tags	= jQuery('.rsmg-all-tags').find('.rsmg-use-tags:checked');

		if (to_remove_tags.length) {
			var photo_tags = this.getPhotoTags();

			// Remove selected tags from the existing ones if present
			jQuery.each(to_remove_tags, function(key, tag) {
				tag = jQuery(tag).val();

				if (RSMediaGallery.Helpers.inArray(tag, photo_tags)) {
					photo_tags = RSMediaGallery.Helpers.removeFromArray(tag.trim(), photo_tags, 'value');
				}
			});

			// Put the tags in the specific textarea
			tags_container.val(photo_tags.join(', '));
		} else {
			alert(rsmgGetLang('COM_RSMEDIAGALLERY_NO_TAGS_SELCTED'));
		}
	}
};