var rsmg_layout;

jQuery(document).ready(function () {

	// Hide previous button
    if (jQuery('#rsmg_prev_page').length > 0) {
		jQuery('#rsmg_prev_page').hide();
	}

	var view = jQuery('.rsmg-main-container').attr('data-layout');

	// Gallery items
    rsmgInitLoadMore();
	rsmgInitItems();

	if (view == 'album' || view == 'gallery') {
		rsmgInitLayout();
	} else if (view == 'filter') {
		rsmgInitGalleryFilter();
		rsmgSetTagsFilters();
	} else if (view == 'image') {
		jQuery('.rsmg-loader-container').remove();
	}
});

function rsmgGetLang(constant, arg) {
    var text = Joomla.JText._(constant);

    if (arg) {
        if (text.indexOf('%s') > -1) {
            text = text.replace('%s', arg);
        } else if (text.indexOf('%d') > -1) {
            text = text.replace('%d', arg);
        }
    }

    return text;
}

function rsmgSetTagsFilters() {
	var visible_tags = [];
	
	jQuery('.rsmg-gallery > li').each(function() {
		var tags = jQuery(this).attr('data-category');

		if (tags) {
			tags = tags.split(', ');

			if (tags.length > 0) {
				for (var i = 0; i < tags.length; i++) {
					visible_tags.push(tags[i]);
				}
			}
		}
	});

	if (visible_tags.length > 0) {
		var unique_array	= [],
            has_filters		= jQuery('.rsmg-gallery-filters').length;

		jQuery.each(visible_tags, function(index, elem) {
			if (!inArray(elem, unique_array)) {
				unique_array.push(elem);
			}
		});

		if (has_filters > 0) {
			jQuery('.rsmg-gallery-filters > li').each(function() {
				var tag = jQuery(this).attr('data-filter');

				if (tag != 'all') {
					if (inArray(tag, unique_array)) {
						jQuery(this).removeClass('rsmg-hidden');
					}
				}
			});
		}
	}
}

function rsmgInitLayout() {
	if (jQuery('.rsmg-gallery > li').length > 0) {
		rsmg_layout = jQuery('.rsmg-gallery').filterizr({
			layout              : 'sameWidth',
			gridItemsSelector	: '.rsmg-gallery > li',
			callbacks			: {
				onFilteringEnd	: function() {
					rsmgInitMagnificPopup();
				}
			}
		});
	}
}

function rsmgLayoutAddItems() {
	if (jQuery('.rsmg-gallery > li.added').length > 0) {
		jQuery('.rsmg-gallery > li.added').each(function() {
			jQuery(this).removeClass('added');
			rsmg_layout.filterizr('insertItem', jQuery(this).get(0));
			jQuery(this).remove();
		});

		rsmgInitMagnificPopup();
	}
}

function rsmgInitLoadMore() {
    if (jQuery('#rsmg_load_more').length > 0) {

        var total_items = jQuery('#rsmg_load_more').attr('rel'),
            left_items  = 0,
            children    = jQuery('.rsmg-gallery .rsmg-item-container').length;
		
        if (total_items > 0) {
            left_items = total_items - children;
        }
        if (total_items < 0) {
            left_items = 0;
        }

        jQuery('#rsmg_load_more').attr('rel', left_items);
        jQuery('#rsmg_load_more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_MORE', jQuery('#rsmg_load_more').attr('rel')));

        jQuery('#rsmg_load_more').on('click', function(e) {
            e.preventDefault();

            e.shiftKey ? rsmgGetItems(false, {
                limitall    : 1,
                limit       : jQuery('#rsmg_load_more').attr('rel')
            }) : rsmgGetItems();
        });

        jQuery(document).keydown(function (e) {
            if (e.shiftKey) jQuery('#rsmg_load_more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_ALL', jQuery('#rsmg_load_more').attr('rel')));
        });
        jQuery(document).keyup(function (e) {
            jQuery('#rsmg_load_more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_MORE', jQuery('#rsmg_load_more').attr('rel')));
        });
    }
}

function rsmgGetOriginalLimitstart() {
    return parseInt(jQuery('#rsmg_original_limitstart').val());
}

function rsmgInitItems() {

	// Initialize lightbox
	if (typeof rsmgInitMagnificPopup == 'function') {
		rsmgInitMagnificPopup();
	}
}

function inArray(needle, haystack) {
    var length = haystack.length;

    for (var i = 0; i < length; i++) {
        if (haystack[i] == needle) return true;
    }

    return false;
}

function rsmgGetItemsFilter(more, album_view) {
	var children	= jQuery('.rsmg-gallery .rsmg-item-container').length,
		data		= {};

    if (album_view) {
		data = {
			limitstart	: children + rsmgGetOriginalLimitstart(),
			Itemid		: jQuery('#rsmg_itemid').val(),
			tag			: jQuery('#rsmg_selected_tag').val()
		};
	} else {
		data = {
			limitstart	: children + rsmgGetOriginalLimitstart(),
			Itemid		: jQuery('#rsmg_itemid').val()
		};
	}

    if (more) {
		for (var k in more) {
			data[k] = more[k];
		}
	}

    return data;
}

function rsmgGetItems(clear, more, successFunction, override_async) {
	var album_view	= jQuery('.rsmg-main-container').attr('data-layout') == 'album' ? true : false,
		size		= jQuery('.rsmg-main-container').attr('data-size'),
		gallery		= jQuery('.rsmg-gallery'),
		url_post	= album_view ? rsmgGetRoot() + '/index.php?option=com_rsmediagallery&task=getItemsAlbum&format=raw' : rsmgGetRoot() + '/index.php?option=com_rsmediagallery&task=getitems&format=raw';

	// Clear contents
    if (clear == true) {
		gallery.empty();
	}
		
    if (override_async === false) {
		override_async = false;
	} else {
		override_async = true;
	}

    jQuery.ajax({
        type		: 'POST',
        url			: url_post,
        data		: rsmgGetItemsFilter(more, album_view),
        async		: override_async,
		dataType	: 'json',
        beforeSend	: function() {

            var loader_container	= jQuery('<li>',	{'class'	: 'rsmg-loader-container'}),
				loader				= jQuery('<div>',	{'class'	: 'rsmg-loader'});

			loader_container.append(loader);
			
			// Add items loader
            gallery.append(loader_container);

			// Add loading bar
			if (typeof RSMGLoadingBar != 'undefined') {
				RSMGLoadingBar.startLoader();
			}

			// Hide load more
            jQuery('#rsmg_load_more').fadeOut(300);
        },
        success		: function(data) {
			// Remove items loader
           	gallery.find('.rsmg-loader-container').remove();

			// Remove loading bar
			if (typeof RSMGLoadingBar != 'undefined') {
				RSMGLoadingBar.endLoader();
			}

            if (typeof data == 'object' && data.items && data.total) {

				// check if animation is enabled
				var animation		= (data.animation ? data.animation : false),
				    search          = (data.search ? data.search : false),
					k				= gallery.find('.rsmg-item-container').length,
					loaded_images	= [];

                jQuery(data.items).each(function (index, item) {
					loaded_images.push(item.thumb);

                    var rsmg_col					= jQuery('<li>',	{
							'class'			: 'rsmg-col-' + rsmg_items_per_row + ((animation != 0 || search != 0) ? ' filtr-item' : '') + ' added',
							'data-category'	: item.niceTags.replaceAll(' ', ', ')
                    	}),
						rsmg_item_container			= jQuery('<div>',	{'class' : 'rsmg-item-container'}),
						rsmg_item_link				= jQuery('<a>',		{
							'class' : 'rsmg-item-link',
							'href'	: item.href
						}),
						rsmg_item_thumb_container	= jQuery('<div>',	{'class' : 'rsmg-item-thumb-container'}),
						rsmg_item_thumb				= jQuery('<div>',	{'class' : 'rsmg-item-thumb'}),
						rsmg_item_thumb_img			= jQuery('<img>',	{
							'src'	: item.thumb,
							'alt'	: item.title
						}),
						rsmg_item_thumb_zoom		= jQuery('<div>',	{'class' : 'rsmg-hover-zoom'});

					rsmg_item_thumb_container.append(rsmg_item_thumb.append(rsmg_item_thumb_img).append(rsmg_item_thumb_zoom));

                    // Add item thumb container to item anchor
					rsmg_item_link.append(rsmg_item_thumb_container);

					if ((item.show_title_list && item.title != '') || (item.show_description_list && item.description != '')) {

						var rsmg_item_body = jQuery('<div>',            {'class' : 'rsmg-item-body'});

						// Add item title to data container
						if (item.show_title_list && item.title != '') {
							var rsmg_item_title = jQuery('<h2>', {
									'class' : 'rsmg-item-title',
									'text'	: item.title
								});

							rsmg_item_body.append(rsmg_item_title);
						}

						// Add item description to data container
						if (item.show_description_list && item.description != '') {
							var rsmg_item_description = jQuery('<div>', {'class' : 'rsmg-item-description'}).html(item.description);

							rsmg_item_body.append(rsmg_item_description);
						}

						// Add item data to item anchor
						rsmg_item_link.append(rsmg_item_body);
					}

					// Social sharing container
					if (rsmg_social_sharing_on_thumbs) {
						var social_sharing = jQuery('<div>', {'class' : 'rsmg-social-sharing'});

						// Facebook
						if (rsmg_sharing_facebook) {
							var share_facebook = jQuery('<a>', {
									'class'		: 'rsmg-share',
									'href'		: 'http://www.facebook.com/sharer.php?s=100&p[title]=' + encodeURIComponent(item.title) + '&p[summary]=' + encodeURIComponent(item.description) + '&p[url]=' + encodeURIComponent(item.social_href) + '&p[images][0]=' + encodeURIComponent(item.thumb),
									'target'	: '_blank',
									'title'		: rsmgGetLang('COM_RSMEDIAGALLERY_SHARE_ON_FACEBOOK')
								}),
								facebook_icon	= jQuery('<i>', {'class' : 'rsmg-social-icon-facebook'});

							social_sharing.append(share_facebook.append(facebook_icon));
						}

						// Twitter
						if (rsmg_sharing_twitter) {
							var share_twitter	= jQuery('<a>', {
									'href'		: 'http://twitter.com/share?text=' + encodeURIComponent(item.title) + '&url=' + encodeURIComponent(item.social_href),
									'class'		: 'rsmg-share',
									'target'	: '_blank',
									'title'		: rsmgGetLang('COM_RSMEDIAGALLERY_SHARE_ON_TWITTER')
								}),
								twitter_icon	= jQuery('<i>', {'class' : 'rsmg-social-icon-twitter'});

							social_sharing.append(share_twitter.append(twitter_icon));
						}

                        // Pinterest
                        if (rsmg_sharing_pinterest) {
                            var share_pinterest	= jQuery('<a>', {
									'href'			: 'https://www.pinterest.com/pin/create/button/?url=' + encodeURIComponent(item.social_href) + '&media=' + encodeURIComponent(item.full) + '&description=' + encodeURIComponent(item.description),
									'class'			: 'rsmg-share',
									'target'		: '_blank',
									'title'			: rsmgGetLang('COM_RSMEDIAGALLERY_SHARE_ON_PINTEREST'),
									'data-pin-do'	: 'buttonPin'
								}),
								pinterest_icon	= jQuery('<i>', {'class' : 'rsmg-social-icon-pinterest'})

                            social_sharing.append(share_pinterest.append(pinterest_icon));
                        }
					}

					if (size == 'height') {
						rsmg_item_thumb_container.css('padding-top', item.thumb_height + 'px');
					} else {
						rsmg_item_container.css('max-width', item.thumb_width + 'px');
					}
					

                    // Add item data attributes to item anchor
                    rsmg_item_link.attr({
                        'data-mfp-src'          : item.full,
                        'data-max-width'        : item.full_width,
                        'data-max-height'       : item.full_height,

                        'data-item-id'       	: item.id,
                        'data-item-title'       : item.title,
                        'data-item-description' : item.description,

                        'data-item-download'    : item.download,
                        'data-share-facebook'   : (rsmg_social_sharing_on_details && rsmg_sharing_facebook) ? 'https://www.facebook.com/sharer.php?u=' + encodeURIComponent(item.social_href) : '',
                        'data-share-twitter'    : (rsmg_social_sharing_on_details && rsmg_sharing_twitter) ? 'https://twitter.com/share?text=' + item.title + '&url=' + encodeURIComponent(item.social_href) : '',
                        'data-share-pinterest'  : (rsmg_social_sharing_on_details && rsmg_sharing_pinterest) ? 'https://www.pinterest.com/pin/create/button/?url=' + encodeURIComponent(item.social_href) + '&media=' + encodeURIComponent(item.full) + '&description=' + encodeURIComponent(item.description) : '',
                        'data-item-tags'        : item.tags,
						'data-item-hits'		: item.hits,
                        'data-item-created'     : item.created,
                        'data-item-modified'    : item.modified
                    });

                    // Add item anchor to item container
					rsmg_item_container.append(rsmg_item_link);

                    // Add social sharing to item container
					if (rsmg_social_sharing_on_thumbs) {
						rsmg_item_container.append(social_sharing);
					}

					// Add item to container
					rsmg_col.append(rsmg_item_container);

                    // Add item container to gallery
					gallery.append(rsmg_col);
					
                    k++;
                });
				
				// Initialize items (+ lightbox if available)
				rsmgInitItemsLoaded(loaded_images);

				// Reset gallery filters
				if (animation != 0 || search != 0) {
					rsmgInitGalleryFilter(true);
					rsmgSetTagsFilters();
				} else {
					rsmgLayoutAddItems();
				}
				
				// Show load more
				var original_limitstart = rsmgGetOriginalLimitstart();

                if (data.total > jQuery('.rsmg-gallery .rsmg-item-container').length + original_limitstart) {
                    var left = data.total - (jQuery('.rsmg-gallery .rsmg-item-container').length + original_limitstart);

                    jQuery('#rsmg_load_more').html(rsmgGetLang('COM_RSMEDIAGALLERY_LOAD_MORE', left));
                    jQuery('#rsmg_load_more').attr('rel', left);
                    jQuery('#rsmg_load_more').fadeIn(500);
                } else {
                    jQuery('#rsmg_load_more').attr('rel', 0);
                }
					
                if (typeof successFunction == 'function') {
                    successFunction(data);
                }
            }
        }
    })
}

function rsmgInitItemsLoaded(loaded_images) {
	var nr_images   = loaded_images.length,
        loaded      = 0,
	    images      = jQuery('.rsmg-gallery .rsmg-item-container .rsmg-item-thumb img');
	
	images.each(function() {
		var src = jQuery(this).attr('src');

		if (inArray(src, loaded_images)){
			jQuery(this).on('load', function(){
				loaded++;

				if (loaded == nr_images) {
					rsmgInitItems();
				}
			});
		}
	});
}

function rsmgHitItem(item_id) {

	if (!isNaN(item_id) && item_id > 0 && !inArray(item_id, rsmg_hit)) {

		// add it to the stacks
		rsmg_hit.push(item_id);
		rsmg_to_hit.push(item_id);

		if (rsmg_hit_timer) {
			clearTimeout(rsmg_hit_timer);
		}

		rsmg_hit_timer = setTimeout(function() {
			// hit it
			jQuery.ajax({
				type	: 'POST',
				url		: rsmgGetRoot() + '/index.php',
				data	: {
					'option'	: 'com_rsmediagallery',
					'task'		: 'hititem',
					'cid'		: rsmg_to_hit
				}
			});

			rsmg_to_hit.length = 0;
		}, 1000);
	}
}

if (!Array.prototype.indexOf) {
	Array.prototype.indexOf = function(elt /*, from*/) {
		var len		= this.length >>> 0,
			from	= Number(arguments[1]) || 0;

		from = (from < 0)
			 ? Math.ceil(from)
			 : Math.floor(from);
		if (from < 0)
			from += len;

		for (; from < len; from++) {
			if (from in this && this[from] === elt) {
				return from;
			}
		}

		return -1;
	};
}

if (!Array.prototype.chunk) {
	Array.prototype.chunk = function(chunk_size) {
		var array = this;

		return [].concat.apply([],
			array.map(function(elem, i) {
				return i % chunk_size ? [] : [array.slice(i,i + chunk_size)];
			})
		);
	}
}

var rsmg_hit 	   = [],
	rsmg_to_hit	   = [],
	rsmg_hit_timer = false;