<?php
/**
* @package RSMediaGallery!
* @copyright (C) 2011 - 2021 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');
?>

<?php if(!empty($this->classFx)) { ?>
    <div class="<?php echo $this->classFx;?>-inner-album">
<?php } ?>
    <?php if ($this->tag != '' && $this->params->get('show_page_heading', 0)) { ?>
        <h1><?php echo $this->escape($this->tag); ?></h1>
    <?php } ?>

        <div class="rsmg-main-container<?php echo $this->params->get('center_list') ? ' rsmg-center' : ''; ?><?php echo $this->params->get('open_in') == 'slideshow' ? ' rsmg-slideshow' : ''; ?>" data-layout="album" data-size="<?php echo ($this->params->get('thumb_width') ? 'width' : 'height'); ?>">
            <?php if ($this->prev) { ?>
                <a href="<?php echo RSMediaGalleryRoute::_('index.php?option=com_rsmediagallery&view=album&tag='.urlencode($this->tag).($this->limitstart - $this->limit > 0 ? '&limitstart='.($this->limitstart - $this->limit) : '')); ?>" id="rsmg_prev_page" class="rsmg-block-button"><?php echo JText::_('COM_RSMEDIAGALLERY_PREV_PAGE'); ?></a>
            <?php } ?>

            <?php if ($this->items) { ?>
                <ul class="rsmg-gallery">
                    <?php
                    foreach ($this->items as $i => $item) {
                        $item_data_attributes = 'data-mfp-src="' . addslashes($item->full) . '"';
                        $item_data_attributes .= ' data-max-width="' . $item->full_width . '"';
                        $item_data_attributes .= ' data-max-height="' . $item->full_height . '"';

                        $item_data_attributes .= ' data-item-id="' . $item->id . '"';
                        $item_data_attributes .= ' data-item-title="' . ($this->params->get('show_title_detail', 1) ? $this->escape($item->title) : '') . '"';
                        $item_data_attributes .= ' data-item-description="' . ($this->params->get('show_description_detail', 1) ? $item->full_description : '') . '"';

                        $item_data_attributes .= ' data-item-download="' . ($this->params->get('download_original', 1) ? $item->download : '') . '"';
                        $item_data_attributes .= ' data-share-facebook="' . ($this->social_on_details && $this->share_facebook ? 'https://www.facebook.com/sharer.php?u='.urlencode($item->social_href) : '') . '"';
                        $item_data_attributes .= ' data-share-twitter="' . ($this->social_on_details && $this->share_twitter ? 'https://twitter.com/share?text='.$this->escape($item->title.'&url='.$this->buildTwitterLink($item->social_href)) : '') . '"';
                        $item_data_attributes .= ' data-share-pinterest="' . ($this->social_on_details && $this->share_pinterest ? 'https://www.pinterest.com/pin/create/button/?url='.urlencode($item->social_href).'&media='.urlencode($item->full).'&description='.urlencode($this->escape($item->description))  : '') . '"';

                        $item_data_attributes .= ' data-item-tags="' . ($this->params->get('show_tags', 1) ? $this->escape($item->tags) : '') . '"';
                        $item_data_attributes .= ' data-item-hits="' . ($this->params->get('show_hits', 1) ? $item->hits : '') . '"';
                        $item_data_attributes .= ' data-item-created="' . ($this->params->get('show_created', 1) ? $this->escape($item->created) : '') . '"';
                        $item_data_attributes .= ' data-item-modified="' . ($this->params->get('show_modified', 1) ? $this->escape($item->modified) : '') . '"';
                    ?>
                        <li class="rsmg-col-<?php echo $this->itemsrow; ?>" data-category="<?php echo RSMediaGalleryHelper::niceTag($this->tag); ?>">
                            <div class="rsmg-item-container"<?php echo $this->thumb_max_size; ?>>
                                <a class="rsmg-item-link" <?php if ($this->params->get('open_in_new_page', 0)) { ?>target="_blank"<?php } ?> href="<?php echo $item->href; ?>" <?php echo $item_data_attributes; ?>>
                                    <div class="rsmg-item-thumb-container"<?php echo $this->thumb_container_height; ?>>
                                        <div class="rsmg-item-thumb">
                                            <img src="<?php echo $item->thumb; ?>" alt="<?php echo $this->escape($item->title); ?>"/>
                                            <div class="rsmg-hover-zoom"></div>
                                        </div>
                                    </div><!-- rsmg-item-thumb-container -->
                                    <?php if (($this->params->get('show_title_list', 1) && $this->escape($item->title) != '') || ($this->params->get('show_description_list', 1) && $item->description != '')) { ?>
                                        <div class="rsmg-item-body">
                                            <?php if ($this->params->get('show_title_list', 1) && $this->escape($item->title) != '') { ?>
                                                <h2 class="rsmg-item-title"><?php echo $this->escape($item->title); ?></h2>
                                            <?php } ?>
                                            <?php if ($this->params->get('show_description_list', 1) && $item->description != '') { ?>
                                                <div class="rsmg-item-description"><?php echo $item->description; ?></div>
                                            <?php } ?>
                                        </div><!-- rsmg-item-body -->
                                    <?php } ?>
                                </a>

                                <?php if ($this->social_sharing && $this->social_on_thumbs) { ?>
                                <div class="rsmg-social-sharing">
                                    <?php if ($this->share_facebook) { ?>
                                        <a class="rsmg-share" title="<?php echo JText::_('COM_RSMEDIAGALLERY_SHARE_ON_FACEBOOK')?>" target="_blank" href="http://www.facebook.com/sharer.php?s=100&amp;p[title]=<?php echo urlencode($this->escape($item->title));?>&amp;p[summary]=<?php echo urlencode($this->escape($item->description)) ?>&amp;p[url]=<?php echo urlencode($item->social_href); ?>&amp;p[images][0]=<?php echo urlencode($item->thumb); ?>"><i class="rsmg-social-icon-facebook"></i></a>
                                    <?php } ?>
                                    <?php if ($this->share_twitter) { ?>
                                        <a class="rsmg-share" title="<?php echo JText::_
                                        ('COM_RSMEDIAGALLERY_SHARE_ON_TWITTER')?>" target="_blank" href="http://twitter.com/share?text=<?php echo $this->escape($item->title) ?>&url=<?php echo $this->buildTwitterLink($item->social_href); ?>"><i class="rsmg-social-icon-twitter"></i></a>
                                    <?php } ?>
                                    <?php if ($this->share_pinterest) { ?>
                                        <a class="rsmg-share" title="<?php echo JText::_('COM_RSMEDIAGALLERY_SHARE_ON_PINTEREST')?>" target="_blank" href="https://www.pinterest.com/pin/create/button/?url=<?php echo urlencode($item->social_href); ?>&media=<?php echo urlencode($item->full);?>&description=<?php echo urlencode($this->escape($item->description)) ?>" data-pin-do="buttonPin"><i class="rsmg-social-icon-pinterest"></i></a>
                                    <?php } ?>
                                </div><!-- rsmg-social-sharing -->
                                <?php } ?>
                            </div><!-- rsmg-item-container -->
                        </li>
                    <?php } ?>
                </ul><!-- rsmg-gallery -->
            <?php } ?>

            <?php if ($this->more) { ?>
                <a href="<?php echo RSMediaGalleryRoute::_('index.php?option=com_rsmediagallery&view=album&tag='.urlencode($this->tag).'&limitstart='.($this->limitstart + $this->limit)); ?>" rel="<?php echo $this->total - $this->limitstart; ?>" id="rsmg_load_more" class="rsmg-block-button"><?php echo JText::_('COM_RSMEDIAGALLERY_NEXT_PAGE'); ?></a><!-- load more -->
                <input type="hidden" name="tag" id="rsmg_selected_tag" value="<?php echo $this->tag; ?>" />
            <?php } ?>

            <input type="hidden" name="Itemid" id="rsmg_itemid" value="<?php echo $this->itemid; ?>" />
            <input type="hidden" id="rsmg_original_limitstart" value="<?php echo $this->limitstart; ?>" />
        </div><!-- rsmg-main-container -->
    <?php if ($this->params->get('show_credits', 1)) { ?>
        <div class="rsmg-footer">
            <?php echo JText::sprintf('COM_RSMEDIAGALLERY_FOOTER_CREDITS', 'https://www.rsjoomla.com/joomla-extensions/joomla-gallery.html'); ?>
        </div>
    <?php } ?>
<?php if (!empty($this->classFx)) { ?>
    </div>
<?php } ?>

<?php if ($this->loadingbar != 'none') { ?>
    <script type="text/javascript">
        RSMGLoadingBar.direction = '<?php echo $this->loadingbar; ?>';
    </script>
<?php } ?>