<?php
/**
 * @package RSMediaGallery!
 * @copyright (C) 2011 - 2021 www.rsjoomla.com
 * @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
 */

defined('_JEXEC') or die('Restricted access');
?>

<?php if (!empty($this->classFx)) { ?>
    <div class="<?php echo $this->classFx; ?>">
<?php } ?>
<?php if ($this->params->get('show_page_heading', 1)) { ?>
    <h1><?php echo $this->escape($this->params->get('page_heading')); ?></h1>
<?php } ?>

    <div class="rsmg-main-container<?php echo $this->params->get('center_albums') ? ' rsmg-center' : ''; ?>">
		<?php if (count($this->tags)) { ?>
        <ul class="rsmg-albums">
            <?php foreach($this->tags as $i => $tag) {
                if (count($this->items[$tag])) {
            ?>
                <li class="rsmg-col-<?php echo $this->itemsrow; ?>">
                    <div class="rsmg-album-container" style="max-width: <?php echo $this->preview_res[1] . 'px'; ?>">
                        <div class="rsmg-album-inner-container">
                            <a href="<?php echo $this->links[$tag]; ?>" class="rsmg-album-thumbs<?php echo
                            count($this->items[$tag]) > 1 ? ' rsmg-collage-'.count($this->items[$tag]) : ''; ?>">
                                <?php foreach ($this->items[$tag] as $item) { ?>
                                    <span>
                                        <img src="<?php echo $item->thumb; ?>" alt="<?php echo $item->title; ?>"/>
                                    </span>
                                <?php } ?>
                                <div class="rsmg-hover-plus"></div>
                            </a>
                        </div>
                        <?php if ($this->params->get('show_tags_album', 1)) { ?>
                            <a class="rsmg-title" href="<?php echo $this->links[$tag]; ?>">
                                <?php echo $this->escape($tag);?>
                            </a>
                        <?php } ?>
                        <input type="hidden" class="rsmg_special_title" value="<?php echo $this->escape($tag); ?>"/>
                    </div>
                </li>
            <?php
                }
            }
            ?>
        </ul>
		<?php } else {
			JLog::add(JText::_('COM_RSMEDIAGALLERY_PLEASE_ADD_TAG'), JLog::NOTICE);
		} ?>
    </div><!-- rsmg-main-container -->
<?php if ($this->params->get('show_credits', 1)) { ?>
    <div class="rsmg-footer">
        <?php echo JText::sprintf('COM_RSMEDIAGALLERY_FOOTER_CREDITS', 'https://www.rsjoomla.com/joomla-extensions/joomla-gallery.html'); ?>
    </div>
<?php } ?>
<?php if (!empty($this->classFx)) { ?>
    </div>
<?php } ?>