<?php
/**
* @package RSMediaGallery!
* @copyright (C) 2011 - 2021 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');
?>

<?php if (!empty($this->classFx)) { ?>
	<div class="<?php echo $this->classFx; ?>-image">
<?php } ?>
<?php if ($this->params->get('show_page_heading', 1)) { ?>
	<h1><?php echo $this->escape($this->item->title); ?></h1>
<?php } ?>
	<div class="rsmg-main-container" data-layout="image">
		<?php if ($this->adjacent->prev || $this->adjacent->next) { ?>
			<div class="rsmg-controls">
				<div class="rsmg-prev">
					<?php if ($this->adjacent->prev) { ?>
						<a href="<?php echo RSMediaGalleryRoute::_('index.php?option=com_rsmediagallery&view=rsmediagallery&layout=image&id='.$this->adjacent->prev->filepart.'&ext='.$this->adjacent->prev->fileext); ?>" class="rsmg_float_left"><?php echo JText::_('COM_RSMEDIAGALLERY_PREVIOUS'); ?></a>
					<?php } ?>
				</div>
				<div class="rsmg-next">
					<?php if ($this->adjacent->next) { ?>
						<a href="<?php echo RSMediaGalleryRoute::_('index.php?option=com_rsmediagallery&view=rsmediagallery&layout=image&id='.$this->adjacent->next->filepart.'&ext='.$this->adjacent->next->fileext); ?>" class="rsmg_float_right"><?php echo JText::_('COM_RSMEDIAGALLERY_NEXT'); ?></a>
					<?php } ?>
				</div>
			</div>
		<?php } ?>

		<div class="rsmg-image-container">
			<div class="rsmg-image-thumb">
				<img src="<?php echo $this->item->src; ?>" alt="<?php echo $this->escape($this->item->title); ?>" title="<?php echo $this->escape($this->item->title); ?>" />
			</div>
			<div class="rsmg-image-body">
				<div class="rsmg-image-buttons">
					<div class="rsmg-image-buttons-left">
						<a class="rsmg-round-button" href="<?php echo RSMediaGalleryRoute::_('index.php?option=com_rsmediagallery&view=rsmediagallery'); ?>"><?php echo JText::_('COM_RSMEDIAGALLERY_BACK_TO_ALBUM'); ?></a>
					</div>
					<?php if (($this->social_sharing && $this->social_on_details) || $this->params->get('download_original', 1)) { ?>
						<div class="rsmg-image-buttons-right">
							<?php if ($this->params->get('download_original', 1)) { ?>
								<a class="rsmg-image-download" href="<?php echo RSMediaGalleryRoute::_('index.php?option=com_rsmediagallery&task=downloaditem&id='.$this->item->filepart.'&ext='.$this->item->fileext); ?>" title="<?php echo JText::_('COM_RSMEDIAGALLERY_DOWNLOAD'); ?>"><i class="rsmg-icon-download"></i></a>
							<?php } ?>
							<?php if ($this->share_facebook) { ?>
								<a class="rsmg-share" title="<?php echo JText::_('COM_RSMEDIAGALLERY_SHARE_ON_FACEBOOK')?>" target="_blank" href="http://www.facebook.com/sharer.php?u=<?php echo urlencode($this->currentUrl); ?>"><i class="rsmg-social-icon-facebook"></i></a>
							<?php } ?>
							<?php if ($this->share_twitter) { ?>
								<a class="rsmg-share" title="<?php echo JText::_('COM_RSMEDIAGALLERY_SHARE_ON_TWITTER')?>" target="_blank" href="http://twitter.com/share?text=<?php echo $this->escape($this->item->title) ?>&url=<?php echo $this->buildTwitterLink($this->currentUrl); ?>"><i class="rsmg-social-icon-twitter"></i></a>
							<?php } ?>
							<?php if ($this->share_pinterest) { ?>
								<a class="rsmg-share" title="<?php echo JText::_('COM_RSMEDIAGALLERY_SHARE_ON_PINTEREST')?>" href="https://www.pinterest.com/pin/create/button/?url=<?php echo urlencode($this->currentUrl); ?>&media=<?php echo urlencode($this->item->src);?>&description=<?php echo urlencode($this->escape($this->item->description)) ?>" data-pin-do="buttonPin"><i class="rsmg-social-icon-pinterest"></i></a>
							<?php } ?>
						</div>
					<?php } ?>
				</div><!-- rsmg-image-buttons -->
				<?php if ($this->params->get('show_title_detail', 1) && $this->escape($this->item->title) != '') { ?>
					<h2 class="rsmg-image-title"><?php echo $this->escape($this->item->title); ?></h2>
				<?php } ?>
				<?php if ($this->params->get('show_description_detail', 1) && $this->item->description != '') { ?>
					<div class="rsmg-image-description"><?php echo $this->item->description; ?></div>
				<?php } ?>
				<?php if ($this->params->get('show_tags', 1) || $this->params->get('show_hits', 1) || $this->params->get('show_created', 1) || $this->params->get('show_modified', 1)) { ?>
					<div class="rsmg-image-bottom">
						<?php if ($this->params->get('show_tags', 1)) { ?>
							<div class="rsmg-image-tags">
								<i class="rsmg-icon-tags"></i><?php echo $this->escape($this->item->tags); ?>
							</div>
						<?php } ?>
						<?php if ($this->params->get('show_hits', 1) || $this->params->get('show_created', 1) || $this->params->get('show_modified', 1)) { ?>
							<div class="rsmg-image-info">
								<?php if ($this->params->get('show_hits', 1)) { ?>
									<span class="rsmg-image-hits">
									<i class="rsmg-icon-eye"></i><?php echo $this->item->hits; ?>
								</span>
								<?php } ?>
								<?php if ($this->params->get('show_created', 1)) { ?>
									<span class="rsmg-image-created">
									<i class="rsmg-icon-calendar"></i><?php echo $this->escape($this->item->created); ?>
								</span>
								<?php } ?>
								<?php if ($this->params->get('show_modified', 1)) { ?>
									<span class="rsmg-image-modified">
									<i class="rsmg-icon-edit"></i><?php echo $this->escape($this->item->modified); ?>
								</span>
								<?php } ?>
							</div>
						<?php } ?>
					</div><!-- rsmg-image-bottom -->
				<?php } ?>
			</div><!-- rsmg-image-body -->
		</div><!-- rsmg-image-container -->
		<div class="rsmg-loader-container">
			<div class="rsmg-loader"></div>
		</div>
	</div><!-- rsmg-main-container -->
<?php if (!empty($this->classFx)) { ?>
	</div>
<?php } ?>